/*
 * *** Please do not edit ! ***
 * @(#) BroadcastAllFacts_1.cs
 * @procedure broadcast_all_facts/1 in dca.pl
 */

/*
 * @version P# 1.1.3, on Sept 1 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class BroadcastAllFacts_1 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate BroadcastAllFacts_1_1 = new Predicates.BroadcastAllFacts_1_1();
    static internal readonly Predicate BroadcastAllFacts_1_2 = new Predicates.BroadcastAllFacts_1_2();
    static internal readonly Predicate BroadcastAllFacts_1_var = new Predicates.BroadcastAllFacts_1_var();

    public Term arg1;

    public BroadcastAllFacts_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public BroadcastAllFacts_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   BroadcastAllFacts_1_var,
                                   dollar_fail_0,
                                   BroadcastAllFacts_1_1,
                                   dollar_fail_0,
                                   BroadcastAllFacts_1_2
                                   );
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "broadcast_all_facts(" + arg1 + ")";
    }
}

sealed class BroadcastAllFacts_1_var : BroadcastAllFacts_1 {
    static internal readonly Predicate BroadcastAllFacts_1_var_1 = new Predicates.BroadcastAllFacts_1_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(BroadcastAllFacts_1_1, BroadcastAllFacts_1_var_1);
    }
}

sealed class BroadcastAllFacts_1_var_1 : BroadcastAllFacts_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(BroadcastAllFacts_1_2);
    }
}

sealed class BroadcastAllFacts_1_1 : BroadcastAllFacts_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.MakeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1;
        a1 = engine.aregs[1].Dereference();
        Predicate cont = engine.cont;

        if ( !s1.Unify(a1, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class BroadcastAllFacts_1_2 : BroadcastAllFacts_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.MakeSymbol("Broadcast: ");
    static internal readonly SymbolTerm f2 = SymbolTerm.MakeSymbol("form1", 1);
    static internal readonly SymbolTerm f4 = SymbolTerm.MakeSymbol("BroadcastAssertTerm", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].Dereference();
        Predicate cont = engine.cont;

        if ( a1.IsList() ){
            a2 = ((ListTerm)a1).car;
            a3 = ((ListTerm)a1).cdr;
        } else if ( a1.IsVariable() ){
            a2 = engine.makeVariable();
            a3 = engine.makeVariable();
            if ( !a1.Unify(new ListTerm(a2, a3), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a5 = engine.makeVariable();
        Term[] h3 = {a5};
        a4 = new StructureTerm(f2, h3);
        Term[] h5 = {a2, engine.makeVariable()};
        a6 = new StructureTerm(f4, h5);
        p1 = new Predicates.BroadcastAllFacts_1(a3, cont);
        p2 = new Predicates.colon_2(a5, a6, p1);
        p3 = new Predicates.GlobalCall_1(a4, p2);
        p4 = new Predicates.dollar_nl_0(p3);
        p5 = new Predicates.Write_1(a2, p4);
        return new Predicates.Write_1(s1, p5);
    }
}
}

