/*
 * *** Please do not edit ! ***
 * @(#) CopyAssertToConnected_1.cs
 * @procedure copy_assert_to_connected/1 in dca.pl
 */

/*
 * @version P# 1.1.3, on Sept 1 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class CopyAssertToConnected_1 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.MakeSymbol("form1", 1);
    static internal readonly SymbolTerm f3 = SymbolTerm.MakeSymbol("BroadcastAssert", 2);

    public Term arg1;

    public CopyAssertToConnected_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public CopyAssertToConnected_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = arg1.Dereference();

        a3 = engine.makeVariable();
        Term[] h2 = {a3};
        a2 = new StructureTerm(f1, h2);
        Term[] h4 = {a1, engine.makeVariable()};
        a4 = new StructureTerm(f3, h4);
        p1 = new Predicates.colon_2(a3, a4, cont);
        return new Predicates.GlobalCall_1(a2, p1);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "copy_assert_to_connected(" + arg1 + ")";
    }
}
}

