/*
 * *** Please do not edit ! ***
 * @(#) DcaAssertWithConflictDetect_3.cs
 * @procedure dca_assert_with_conflict_detect/3 in dca.pl
 */

/*
 * @version P# 1.1.3, on Sept 1 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class DcaAssertWithConflictDetect_3 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.MakeSymbol("/", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.MakeSymbol("fact", 2);
    static internal readonly SymbolTerm f6 = SymbolTerm.MakeSymbol("global_call", 1);

    public Term arg1, arg2, arg3;

    public DcaAssertWithConflictDetect_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public DcaAssertWithConflictDetect_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13;
        Predicate p1, p2, p3;
        a1 = arg1.Dereference();
        a2 = arg2.Dereference();
        a3 = arg3.Dereference();

        if ( a1.IsStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a4 = args[0];
            a5 = args[1];
        } else if (a1.IsVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            Term[] args = {a4, a5};
            if ( !a1.Unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        Term[] h3 = {a4, a5};
        a7 = new StructureTerm(f1, h3);
        Term[] h4 = {a7, a2};
        a6 = new StructureTerm(f2, h4);
        Term[] h5 = {a4, a5};
        a8 = new StructureTerm(f1, h5);
        a9 = engine.makeVariable();
        Term[] h7 = {a4, a5};
        a12 = new StructureTerm(f1, h7);
        Term[] h8 = {a12, a9};
        a11 = new StructureTerm(f2, h8);
        Term[] h9 = {a11};
        a10 = new StructureTerm(f6, h9);
        a13 = engine.makeVariable();
        p1 = new Predicates.dollar_dummyDca__2_5(a4, a5, a2, a3, a13, cont);
        p2 = new Predicates.Findall_3(a9, a10, a13, p1);
        p3 = new Predicates.BacktrackableLock_1(a8, p2);
        return new Predicates.GlobalAssert_1(a6, p3);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "dca_assert_with_conflict_detect(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}
}

