/*
 * *** Please do not edit ! ***
 * @(#) DcaInit_1.cs
 * @procedure dca_init/1 in dca.pl
 */

/*
 * @version P# 1.1.3, on Sept 1 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class DcaInit_1 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.MakeSymbol("/", 2);
    static internal readonly SymbolTerm s2 = SymbolTerm.MakeSymbol("form1");
    static internal readonly IntegerTerm s3 = new IntegerTerm(1);
    static internal readonly Term[] h11 = {s2, s3};
    static internal readonly StructureTerm s4 = new StructureTerm(f1, h11);
    static internal readonly SymbolTerm f5 = SymbolTerm.MakeSymbol("form1", 1);
    static internal readonly SymbolTerm s7 = SymbolTerm.MakeSymbol("fact");
    static internal readonly Term[] h12 = {s7, s3};
    static internal readonly StructureTerm s8 = new StructureTerm(f1, h12);
    static internal readonly SymbolTerm s9 = SymbolTerm.MakeSymbol("pred");
    static internal readonly Term[] h13 = {s9, s3};
    static internal readonly StructureTerm s10 = new StructureTerm(f1, h13);

    public Term arg1;

    public DcaInit_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public DcaInit_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2;
        Predicate p1, p2, p3;
        a1 = arg1.Dereference();

        Term[] h6 = {a1};
        a2 = new StructureTerm(f5, h6);
        p1 = new Predicates.GlobalAbolish_1(s10, cont);
        p2 = new Predicates.GlobalAbolish_1(s8, p1);
        p3 = new Predicates.GlobalAssert_1(a2, p2);
        return new Predicates.GlobalAbolish_1(s4, p3);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "dca_init(" + arg1 + ")";
    }
}
}

