/*
 * *** Please do not edit ! ***
 * @(#) GetTermJjc_2.cs
 * @procedure get_term_jjc/2 in dca.pl
 */

/*
 * @version P# 1.1.3, on Sept 1 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class GetTermJjc_2 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.MakeSymbol("form1", 1);
    static internal readonly SymbolTerm f3 = SymbolTerm.MakeSymbol("GetStringReader", 2);

    public Term arg1, arg2;

    public GetTermJjc_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public GetTermJjc_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2;
        a1 = arg1.Dereference();
        a2 = arg2.Dereference();

        a4 = engine.makeVariable();
        Term[] h2 = {a4};
        a3 = new StructureTerm(f1, h2);
        a6 = engine.makeVariable();
        Term[] h4 = {a1, a6};
        a5 = new StructureTerm(f3, h4);
        p1 = new Predicates.Read_2(a6, a2, cont);
        p2 = new Predicates.colon_2(a4, a5, p1);
        return new Predicates.GlobalCall_1(a3, p2);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "get_term_jjc(" + arg1 + ", " + arg2 + ")";
    }
}
}

