/*
 * *** Please do not edit ! ***
 * @(#) ResetAllAgents_0.cs
 * @procedure reset_all_agents/0 in dca.pl
 */

/*
 * @version P# 1.1.3, on Sept 1 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class ResetAllAgents_0 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.MakeSymbol("form1", 1);
    static internal readonly SymbolTerm f3 = SymbolTerm.MakeSymbol("BroadcastAllRetract", 1);
    static internal readonly SymbolTerm f6 = SymbolTerm.MakeSymbol("ResetAllPorts", 2);

    public ResetAllAgents_0(Predicate cont) {
        this.cont = cont;
    }

    public ResetAllAgents_0(){}
    public override void setArgument(Term[] args, Predicate cont) {
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1, p2, p3, p4, p5;

        a2 = engine.makeVariable();
        Term[] h2 = {a2};
        a1 = new StructureTerm(f1, h2);
        Term[] h4 = {engine.makeVariable()};
        a3 = new StructureTerm(f3, h4);
        a4 = engine.makeVariable();
        a5 = engine.makeVariable();
        Term[] h5 = {a2};
        a6 = new StructureTerm(f1, h5);
        Term[] h7 = {a5, engine.makeVariable()};
        a7 = new StructureTerm(f6, h7);
        p1 = new Predicates.colon_2(a2, a7, cont);
        p2 = new Predicates.GlobalCall_1(a6, p1);
        p3 = new Predicates.dollar_unify_2(a5, a4, p2);
        p4 = new Predicates.GetAllFacts_1(a4, p3);
        p5 = new Predicates.colon_2(a2, a3, p4);
        return new Predicates.GlobalCall_1(a1, p5);
    }

    public override int arity() { return 0; }

    public override string ToString() {
        return "reset_all_agents";
    }
}
}

