/*
 * *** Please do not edit ! ***
 * @(#) ResetAllAgents__O_L_D_0.cs
 * @procedure reset_all_agents_OLD/0 in dca.pl
 */

/*
 * @version P# 1.1.3, on Sept 1 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class ResetAllAgents__O_L_D_0 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.MakeSymbol("form1", 1);
    static internal readonly SymbolTerm f3 = SymbolTerm.MakeSymbol("BroadcastAllRetract", 1);

    public ResetAllAgents__O_L_D_0(Predicate cont) {
        this.cont = cont;
    }

    public ResetAllAgents__O_L_D_0(){}
    public override void setArgument(Term[] args, Predicate cont) {
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4;
        Predicate p1, p2, p3;

        a2 = engine.makeVariable();
        Term[] h2 = {a2};
        a1 = new StructureTerm(f1, h2);
        Term[] h4 = {engine.makeVariable()};
        a3 = new StructureTerm(f3, h4);
        a4 = engine.makeVariable();
        p1 = new Predicates.BroadcastAllFacts_1(a4, cont);
        p2 = new Predicates.GetAllFacts_1(a4, p1);
        p3 = new Predicates.colon_2(a2, a3, p2);
        return new Predicates.GlobalCall_1(a1, p3);
    }

    public override int arity() { return 0; }

    public override string ToString() {
        return "reset_all_agents_OLD";
    }
}
}

