/*
 * *** Please do not edit ! ***
 * @(#) ResolveConflict_4.cs
 * @procedure resolve_conflict/4 in dca.pl
 */

/*
 * @version P# 1.1.3, on Sept 1 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class ResolveConflict_4 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.MakeSymbol("form1", 1);
    static internal readonly SymbolTerm f3 = SymbolTerm.MakeSymbol("ResolveConflict", 4);

    public Term arg1, arg2, arg3, arg4;

    public ResolveConflict_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public ResolveConflict_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1, p2;
        a1 = arg1.Dereference();
        a2 = arg2.Dereference();
        a3 = arg3.Dereference();
        a4 = arg4.Dereference();

        a6 = engine.makeVariable();
        Term[] h2 = {a6};
        a5 = new StructureTerm(f1, h2);
        a8 = engine.makeVariable();
        Term[] h4 = {a1, a2, a3, a8};
        a7 = new StructureTerm(f3, h4);
        p1 = new Predicates.RetractAllExceptOne_2(a1, a8, cont);
        p2 = new Predicates.colon_2(a6, a7, p1);
        return new Predicates.GlobalCall_1(a5, p2);
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "resolve_conflict(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}
}

