/*
 * *** Please do not edit ! ***
 * @(#) colon_2.cs
 * @procedure : /2 in built.pl
 */

/*
 * @version P# 1.1.3, on Sept 1 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class colon_2 : Predicate {

    public Term arg1, arg2;

    public colon_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public colon_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10;
        Predicate p1, p2, p3, p4;
        a1 = arg1.Dereference();
        a2 = arg2.Dereference();

        a4 = engine.makeVariable();
        a5 = engine.makeVariable();
        a3 = new ListTerm(a4, a5);
        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        a9 = new ListTerm(a4, a6);
        a10 = engine.makeVariable();
        p1 = new Predicates.dollar__coloncsTerm_2(a7, a10, cont);
        p2 = new Predicates.dollar_csMethod_3(a1, a8, a10, p1);
        p3 = new Predicates.eq_stop_stop_2(a8, a9, p2);
        p4 = new Predicates.dollar_separateLast_3(a5, a6, a7, p3);
        return new Predicates.eq_stop_stop_2(a2, a3, p4);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return ":(" + arg1 + ", " + arg2 + ")";
    }
}
}

