/*
 * *** Please do not edit ! ***
 * @(#) dollar_separateLast_3.cs
 * @procedure $separate_last/3 in built.pl
 */

/*
 * @version P# 1.1.3, on Sept 1 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_separateLast_3 : Predicate, FcoPredicate {
    static internal readonly System.Type EntryCodeType = typeof( dollar_separateLast_3 );
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_separateLast_3_1 = new Predicates.dollar_separateLast_3_1();
    static internal readonly Predicate dollar_separateLast_3_2 = new Predicates.dollar_separateLast_3_2();
    static internal readonly Predicate dollar_separateLast_3_var = new Predicates.dollar_separateLast_3_var();

    public Term arg1, arg2, arg3;

    public dollar_separateLast_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_separateLast_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.SetEntryCode( EntryCodeType, this );
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_separateLast_3_var,
                                   dollar_fail_0,
                                   dollar_fail_0,
                                   dollar_fail_0,
                                   dollar_separateLast_3_var
                                   );
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$separate_last(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class dollar_separateLast_3_var : dollar_separateLast_3 {
    static internal readonly Predicate dollar_separateLast_3_var_1 = new Predicates.dollar_separateLast_3_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_separateLast_3_1, dollar_separateLast_3_var_1);
    }
}

sealed class dollar_separateLast_3_var_1 : dollar_separateLast_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_separateLast_3_2);
    }
}

sealed class dollar_separateLast_3_1 : dollar_separateLast_3 {
    static internal readonly SymbolTerm s1 = SymbolTerm.MakeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        a1 = engine.aregs[1].Dereference();
        a2 = engine.aregs[2].Dereference();
        a3 = engine.aregs[3].Dereference();
        Predicate cont = engine.cont;

        if ( a1.IsList() ){
            a4 = ((ListTerm)a1).car;
            if ( !s1.Unify(((ListTerm)a1).cdr, engine.trail) )
                return engine.fail();
        } else if ( a1.IsVariable() ){
            a4 = engine.makeVariable();
            if ( !a1.Unify(new ListTerm(a4, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( !s1.Unify(a2, engine.trail) ) return engine.fail();
        if ( !a4.Unify(a3, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_separateLast_3_2 : dollar_separateLast_3 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        a1 = engine.aregs[1].Dereference();
        a2 = engine.aregs[2].Dereference();
        a3 = engine.aregs[3].Dereference();
        Predicate cont = engine.cont;

        if ( a1.IsList() ){
            a4 = ((ListTerm)a1).car;
            a5 = ((ListTerm)a1).cdr;
        } else if ( a1.IsVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            if ( !a1.Unify(new ListTerm(a4, a5), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.IsList() ){
            if ( !a4.Unify(((ListTerm)a2).car, engine.trail) )
                return engine.fail();
            a6 = ((ListTerm)a2).cdr;
        } else if ( a2.IsVariable() ){
            a6 = engine.makeVariable();
            if ( !a2.Unify(new ListTerm(a4, a6), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        engine.aregs[1] = a5;
        engine.aregs[2] = a6;
        engine.aregs[3] = a3;
        engine.cont = cont;
        return engine.GetEntryCode( EntryCodeType ).call( engine );
    }
}
}

