/*
 * *** Please do not edit ! ***
 * @(#) dollar_readTokens1_4.cs
 * @procedure $read_tokens1/4 in inout.pl
 */

/*
 * @version P# 1.1.3, on Sept 1 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_readTokens1_4 : Predicate {
    static internal readonly Predicate dollar_readTokens1_4_1 = new Predicates.dollar_readTokens1_4_1();
    static internal readonly Predicate dollar_readTokens1_4_2 = new Predicates.dollar_readTokens1_4_2();
    static internal readonly Predicate dollar_readTokens1_4_3 = new Predicates.dollar_readTokens1_4_3();
    static internal readonly Predicate dollar_readTokens1_4_4 = new Predicates.dollar_readTokens1_4_4();
    static internal readonly Predicate dollar_readTokens1_4_5 = new Predicates.dollar_readTokens1_4_5();
    static internal readonly Predicate dollar_readTokens1_4_6 = new Predicates.dollar_readTokens1_4_6();
    static internal readonly Predicate dollar_readTokens1_4_7 = new Predicates.dollar_readTokens1_4_7();
    static internal readonly Predicate dollar_readTokens1_4_con = new Predicates.dollar_readTokens1_4_con();
    static internal readonly Predicate dollar_readTokens1_4_str = new Predicates.dollar_readTokens1_4_str();
    static internal readonly Predicate dollar_readTokens1_4_var = new Predicates.dollar_readTokens1_4_var();

    public Term arg1, arg2, arg3, arg4;

    public dollar_readTokens1_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public dollar_readTokens1_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_readTokens1_4_var,
                                   dollar_readTokens1_4_7,
                                   dollar_readTokens1_4_con,
                                   dollar_readTokens1_4_str,
                                   dollar_readTokens1_4_7
                                   );
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "$read_tokens1(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}

sealed class dollar_readTokens1_4_var : dollar_readTokens1_4 {
    static internal readonly Predicate dollar_readTokens1_4_var_1 = new Predicates.dollar_readTokens1_4_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_readTokens1_4_1, dollar_readTokens1_4_var_1);
    }
}

sealed class dollar_readTokens1_4_var_1 : dollar_readTokens1_4 {
    static internal readonly Predicate dollar_readTokens1_4_var_2 = new Predicates.dollar_readTokens1_4_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_readTokens1_4_2, dollar_readTokens1_4_var_2);
    }
}

sealed class dollar_readTokens1_4_var_2 : dollar_readTokens1_4 {
    static internal readonly Predicate dollar_readTokens1_4_var_3 = new Predicates.dollar_readTokens1_4_var_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_readTokens1_4_3, dollar_readTokens1_4_var_3);
    }
}

sealed class dollar_readTokens1_4_var_3 : dollar_readTokens1_4 {
    static internal readonly Predicate dollar_readTokens1_4_var_4 = new Predicates.dollar_readTokens1_4_var_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_readTokens1_4_4, dollar_readTokens1_4_var_4);
    }
}

sealed class dollar_readTokens1_4_var_4 : dollar_readTokens1_4 {
    static internal readonly Predicate dollar_readTokens1_4_var_5 = new Predicates.dollar_readTokens1_4_var_5();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_readTokens1_4_5, dollar_readTokens1_4_var_5);
    }
}

sealed class dollar_readTokens1_4_var_5 : dollar_readTokens1_4 {
    static internal readonly Predicate dollar_readTokens1_4_var_6 = new Predicates.dollar_readTokens1_4_var_6();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_readTokens1_4_6, dollar_readTokens1_4_var_6);
    }
}

sealed class dollar_readTokens1_4_var_6 : dollar_readTokens1_4 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_readTokens1_4_7);
    }
}

sealed class dollar_readTokens1_4_con : dollar_readTokens1_4 {
    static internal readonly Predicate dollar_readTokens1_4_con_1 = new Predicates.dollar_readTokens1_4_con_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_readTokens1_4_2, dollar_readTokens1_4_con_1);
    }
}

sealed class dollar_readTokens1_4_con_1 : dollar_readTokens1_4 {
    static internal readonly Predicate dollar_readTokens1_4_con_2 = new Predicates.dollar_readTokens1_4_con_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_readTokens1_4_3, dollar_readTokens1_4_con_2);
    }
}

sealed class dollar_readTokens1_4_con_2 : dollar_readTokens1_4 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_readTokens1_4_7);
    }
}

sealed class dollar_readTokens1_4_str : dollar_readTokens1_4 {
    static internal readonly Predicate dollar_readTokens1_4_str_1 = new Predicates.dollar_readTokens1_4_str_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_readTokens1_4_1, dollar_readTokens1_4_str_1);
    }
}

sealed class dollar_readTokens1_4_str_1 : dollar_readTokens1_4 {
    static internal readonly Predicate dollar_readTokens1_4_str_2 = new Predicates.dollar_readTokens1_4_str_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_readTokens1_4_4, dollar_readTokens1_4_str_2);
    }
}

sealed class dollar_readTokens1_4_str_2 : dollar_readTokens1_4 {
    static internal readonly Predicate dollar_readTokens1_4_str_3 = new Predicates.dollar_readTokens1_4_str_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_readTokens1_4_5, dollar_readTokens1_4_str_3);
    }
}

sealed class dollar_readTokens1_4_str_3 : dollar_readTokens1_4 {
    static internal readonly Predicate dollar_readTokens1_4_str_4 = new Predicates.dollar_readTokens1_4_str_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_readTokens1_4_6, dollar_readTokens1_4_str_4);
    }
}

sealed class dollar_readTokens1_4_str_4 : dollar_readTokens1_4 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_readTokens1_4_7);
    }
}

sealed class dollar_readTokens1_4_1 : dollar_readTokens1_4 {
    static internal readonly SymbolTerm f1 = SymbolTerm.MakeSymbol("error", 1);
    static internal readonly SymbolTerm s2 = SymbolTerm.MakeSymbol("[]");
    static internal readonly SymbolTerm s3 = SymbolTerm.MakeSymbol("SYNTAX ERROR");
    static internal readonly SymbolTerm s4 = SymbolTerm.MakeSymbol("** ");
    static internal readonly SymbolTerm s5 = SymbolTerm.MakeSymbol(" **");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8;
        a1 = engine.aregs[1].Dereference();
        a2 = engine.aregs[2].Dereference();
        a3 = engine.aregs[3].Dereference();
        a4 = engine.aregs[4].Dereference();
        Predicate cont = engine.cont;

        if ( a1.IsStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a5 = args[0];
        } else if (a1.IsVariable() ){
            a5 = engine.makeVariable();
            Term[] args = {a5};
            if ( !a1.Unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( !s2.Unify(a2, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_fail_0(cont);
        p2 = new Predicates.dollar_readTokensUntilFullstop_0(p1);
        p3 = new Predicates.dollar_nl_0(p2);
        p4 = new Predicates.Write_1(s5, p3);
        p5 = new Predicates.Write_1(a5, p4);
        p6 = new Predicates.Write_1(s4, p5);
        p7 = new Predicates.dollar_nl_0(p6);
        p8 = new Predicates.Write_1(s3, p7);
        return new Predicates.dollar_neckCut_0(p8);
    }
}

sealed class dollar_readTokens1_4_2 : dollar_readTokens1_4 {
    static internal readonly SymbolTerm s1 = SymbolTerm.MakeSymbol("end_of_file");
    static internal readonly SymbolTerm s2 = SymbolTerm.MakeSymbol(".");
    static internal readonly SymbolTerm s3 = SymbolTerm.MakeSymbol("[]");
    static internal readonly ListTerm s4 = new ListTerm(s2, s3);
    static internal readonly ListTerm s5 = new ListTerm(s1, s4);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        a1 = engine.aregs[1].Dereference();
        a2 = engine.aregs[2].Dereference();
        a3 = engine.aregs[3].Dereference();
        a4 = engine.aregs[4].Dereference();
        Predicate cont = engine.cont;

        if ( !s1.Unify(a1, engine.trail) ) return engine.fail();
        if ( !s5.Unify(a2, engine.trail) ) return engine.fail();
        if ( !s3.Unify(a3, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_readTokens1_4_3 : dollar_readTokens1_4 {
    static internal readonly SymbolTerm s1 = SymbolTerm.MakeSymbol(".");
    static internal readonly SymbolTerm s2 = SymbolTerm.MakeSymbol("[]");
    static internal readonly ListTerm s3 = new ListTerm(s1, s2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        a1 = engine.aregs[1].Dereference();
        a2 = engine.aregs[2].Dereference();
        a3 = engine.aregs[3].Dereference();
        a4 = engine.aregs[4].Dereference();
        Predicate cont = engine.cont;

        if ( !s1.Unify(a1, engine.trail) ) return engine.fail();
        if ( !s3.Unify(a2, engine.trail) ) return engine.fail();
        if ( !s2.Unify(a3, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_readTokens1_4_4 : dollar_readTokens1_4 {
    static internal readonly SymbolTerm f1 = SymbolTerm.MakeSymbol("var", 1);
    static internal readonly SymbolTerm s2 = SymbolTerm.MakeSymbol("_");
    static internal readonly Term[] h7 = {s2};
    static internal readonly StructureTerm s3 = new StructureTerm(f1, h7);
    static internal readonly SymbolTerm f4 = SymbolTerm.MakeSymbol("var", 2);
    static internal readonly SymbolTerm f5 = SymbolTerm.MakeSymbol("=", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11;
        Predicate p1;
        a1 = engine.aregs[1].Dereference();
        a2 = engine.aregs[2].Dereference();
        a3 = engine.aregs[3].Dereference();
        a4 = engine.aregs[4].Dereference();
        Predicate cont = engine.cont;

        if ( !s3.Unify(a1, engine.trail) ) return engine.fail();
        if ( a2.IsList() ){
            a5 = ((ListTerm)a2).car;
            a6 = ((ListTerm)a2).cdr;
        } else if ( a2.IsVariable() ){
            a5 = engine.makeVariable();
            a6 = engine.makeVariable();
            if ( !a2.Unify(new ListTerm(a5, a6), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a5.IsStructure() ){
            if (f4 != ((StructureTerm)a5).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a5).args;
            if ( !s2.Unify(args[0],  engine.trail) )
                return engine.fail();
            a7 = args[1];
        } else if (a5.IsVariable() ){
            a7 = engine.makeVariable();
            Term[] args = {s2, a7};
            if ( !a5.Unify(new StructureTerm(f4, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a3.IsList() ){
            a8 = ((ListTerm)a3).car;
            a9 = ((ListTerm)a3).cdr;
        } else if ( a3.IsVariable() ){
            a8 = engine.makeVariable();
            a9 = engine.makeVariable();
            if ( !a3.Unify(new ListTerm(a8, a9), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a8.IsStructure() ){
            if (f5 != ((StructureTerm)a8).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a8).args;
            if ( !s2.Unify(args[0],  engine.trail) )
                return engine.fail();
            if ( !a7.Unify(args[1],  engine.trail) )
                return engine.fail();
        } else if (a8.IsVariable() ){
            Term[] args = {s2, a7};
            if ( !a8.Unify(new StructureTerm(f5, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        Term[] h6 = {s2, a7};
        a11 = new StructureTerm(f5, h6);
        a10 = new ListTerm(a11, a4);
        p1 = new Predicates.dollar_readTokens_3(a6, a9, a10, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_readTokens1_4_5 : dollar_readTokens1_4 {
    static internal readonly SymbolTerm f1 = SymbolTerm.MakeSymbol("var", 1);
    static internal readonly SymbolTerm f2 = SymbolTerm.MakeSymbol("var", 2);
    static internal readonly SymbolTerm f3 = SymbolTerm.MakeSymbol("=", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].Dereference();
        a2 = engine.aregs[2].Dereference();
        a3 = engine.aregs[3].Dereference();
        a4 = engine.aregs[4].Dereference();
        Predicate cont = engine.cont;

        if ( a1.IsStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a5 = args[0];
        } else if (a1.IsVariable() ){
            a5 = engine.makeVariable();
            Term[] args = {a5};
            if ( !a1.Unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.IsList() ){
            a6 = ((ListTerm)a2).car;
            a7 = ((ListTerm)a2).cdr;
        } else if ( a2.IsVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            if ( !a2.Unify(new ListTerm(a6, a7), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a6.IsStructure() ){
            if (f2 != ((StructureTerm)a6).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a6).args;
            if ( !a5.Unify(args[0],  engine.trail) )
                return engine.fail();
            a8 = args[1];
        } else if (a6.IsVariable() ){
            a8 = engine.makeVariable();
            Term[] args = {a5, a8};
            if ( !a6.Unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a9 = engine.makeVariable();
        Term[] h4 = {a5, a8};
        a10 = new StructureTerm(f3, h4);
        p1 = new Predicates.dollar_readTokens_3(a7, a3, a4, cont);
        p2 = new Predicates.dollar_cut_1(a9, p1);
        p3 = new Predicates.dollar_memPair_2(a10, a4, p2);
        return new Predicates.dollar_getLevel_1(a9, p3);
    }
}

sealed class dollar_readTokens1_4_6 : dollar_readTokens1_4 {
    static internal readonly SymbolTerm f1 = SymbolTerm.MakeSymbol("var", 1);
    static internal readonly SymbolTerm f2 = SymbolTerm.MakeSymbol("var", 2);
    static internal readonly SymbolTerm f3 = SymbolTerm.MakeSymbol("=", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12;
        Predicate p1;
        a1 = engine.aregs[1].Dereference();
        a2 = engine.aregs[2].Dereference();
        a3 = engine.aregs[3].Dereference();
        a4 = engine.aregs[4].Dereference();
        Predicate cont = engine.cont;

        if ( a1.IsStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a5 = args[0];
        } else if (a1.IsVariable() ){
            a5 = engine.makeVariable();
            Term[] args = {a5};
            if ( !a1.Unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.IsList() ){
            a6 = ((ListTerm)a2).car;
            a7 = ((ListTerm)a2).cdr;
        } else if ( a2.IsVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            if ( !a2.Unify(new ListTerm(a6, a7), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a6.IsStructure() ){
            if (f2 != ((StructureTerm)a6).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a6).args;
            if ( !a5.Unify(args[0],  engine.trail) )
                return engine.fail();
            a8 = args[1];
        } else if (a6.IsVariable() ){
            a8 = engine.makeVariable();
            Term[] args = {a5, a8};
            if ( !a6.Unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a3.IsList() ){
            a9 = ((ListTerm)a3).car;
            a10 = ((ListTerm)a3).cdr;
        } else if ( a3.IsVariable() ){
            a9 = engine.makeVariable();
            a10 = engine.makeVariable();
            if ( !a3.Unify(new ListTerm(a9, a10), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a9.IsStructure() ){
            if (f3 != ((StructureTerm)a9).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a9).args;
            if ( !a5.Unify(args[0],  engine.trail) )
                return engine.fail();
            if ( !a8.Unify(args[1],  engine.trail) )
                return engine.fail();
        } else if (a9.IsVariable() ){
            Term[] args = {a5, a8};
            if ( !a9.Unify(new StructureTerm(f3, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        Term[] h4 = {a5, a8};
        a12 = new StructureTerm(f3, h4);
        a11 = new ListTerm(a12, a4);
        p1 = new Predicates.dollar_readTokens_3(a7, a10, a11, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_readTokens1_4_7 : dollar_readTokens1_4 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        a1 = engine.aregs[1].Dereference();
        a2 = engine.aregs[2].Dereference();
        a3 = engine.aregs[3].Dereference();
        a4 = engine.aregs[4].Dereference();
        Predicate cont = engine.cont;

        if ( a2.IsList() ){
            if ( !a1.Unify(((ListTerm)a2).car, engine.trail) )
                return engine.fail();
            a5 = ((ListTerm)a2).cdr;
        } else if ( a2.IsVariable() ){
            a5 = engine.makeVariable();
            if ( !a2.Unify(new ListTerm(a1, a5), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        return new Predicates.dollar_readTokens_3(a5, a3, a4, cont);
    }
}
}

