/*
 * *** Please do not edit ! ***
 * @(#) dollar_writeOpType_2.cs
 * @procedure $write_op_type/2 in inout.pl
 */

/*
 * @version P# 1.1.3, on Sept 1 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_writeOpType_2 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_writeOpType_2_1 = new Predicates.dollar_writeOpType_2_1();
    static internal readonly Predicate dollar_writeOpType_2_2 = new Predicates.dollar_writeOpType_2_2();
    static internal readonly Predicate dollar_writeOpType_2_3 = new Predicates.dollar_writeOpType_2_3();
    static internal readonly Predicate dollar_writeOpType_2_4 = new Predicates.dollar_writeOpType_2_4();
    static internal readonly Predicate dollar_writeOpType_2_5 = new Predicates.dollar_writeOpType_2_5();
    static internal readonly Predicate dollar_writeOpType_2_6 = new Predicates.dollar_writeOpType_2_6();
    static internal readonly Predicate dollar_writeOpType_2_7 = new Predicates.dollar_writeOpType_2_7();
    static internal readonly Predicate dollar_writeOpType_2_var = new Predicates.dollar_writeOpType_2_var();

    public Term arg1, arg2;

    public dollar_writeOpType_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_writeOpType_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_writeOpType_2_var,
                                   dollar_writeOpType_2_var,
                                   dollar_fail_0,
                                   dollar_fail_0,
                                   dollar_fail_0
                                   );
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$write_op_type(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_writeOpType_2_var : dollar_writeOpType_2 {
    static internal readonly Predicate dollar_writeOpType_2_var_1 = new Predicates.dollar_writeOpType_2_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_writeOpType_2_1, dollar_writeOpType_2_var_1);
    }
}

sealed class dollar_writeOpType_2_var_1 : dollar_writeOpType_2 {
    static internal readonly Predicate dollar_writeOpType_2_var_2 = new Predicates.dollar_writeOpType_2_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_writeOpType_2_2, dollar_writeOpType_2_var_2);
    }
}

sealed class dollar_writeOpType_2_var_2 : dollar_writeOpType_2 {
    static internal readonly Predicate dollar_writeOpType_2_var_3 = new Predicates.dollar_writeOpType_2_var_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_writeOpType_2_3, dollar_writeOpType_2_var_3);
    }
}

sealed class dollar_writeOpType_2_var_3 : dollar_writeOpType_2 {
    static internal readonly Predicate dollar_writeOpType_2_var_4 = new Predicates.dollar_writeOpType_2_var_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_writeOpType_2_4, dollar_writeOpType_2_var_4);
    }
}

sealed class dollar_writeOpType_2_var_4 : dollar_writeOpType_2 {
    static internal readonly Predicate dollar_writeOpType_2_var_5 = new Predicates.dollar_writeOpType_2_var_5();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_writeOpType_2_5, dollar_writeOpType_2_var_5);
    }
}

sealed class dollar_writeOpType_2_var_5 : dollar_writeOpType_2 {
    static internal readonly Predicate dollar_writeOpType_2_var_6 = new Predicates.dollar_writeOpType_2_var_6();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_writeOpType_2_6, dollar_writeOpType_2_var_6);
    }
}

sealed class dollar_writeOpType_2_var_6 : dollar_writeOpType_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_writeOpType_2_7);
    }
}

sealed class dollar_writeOpType_2_1 : dollar_writeOpType_2 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(1);
    static internal readonly SymbolTerm s2 = SymbolTerm.MakeSymbol("fx");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].Dereference();
        a2 = engine.aregs[2].Dereference();
        Predicate cont = engine.cont;

        if ( !s1.Unify(a1, engine.trail) ) return engine.fail();
        if ( !s2.Unify(a2, engine.trail) ) return engine.fail();
        return cont;
    }
}

sealed class dollar_writeOpType_2_2 : dollar_writeOpType_2 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(1);
    static internal readonly SymbolTerm s2 = SymbolTerm.MakeSymbol("fy");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].Dereference();
        a2 = engine.aregs[2].Dereference();
        Predicate cont = engine.cont;

        if ( !s1.Unify(a1, engine.trail) ) return engine.fail();
        if ( !s2.Unify(a2, engine.trail) ) return engine.fail();
        return cont;
    }
}

sealed class dollar_writeOpType_2_3 : dollar_writeOpType_2 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(1);
    static internal readonly SymbolTerm s2 = SymbolTerm.MakeSymbol("xf");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].Dereference();
        a2 = engine.aregs[2].Dereference();
        Predicate cont = engine.cont;

        if ( !s1.Unify(a1, engine.trail) ) return engine.fail();
        if ( !s2.Unify(a2, engine.trail) ) return engine.fail();
        return cont;
    }
}

sealed class dollar_writeOpType_2_4 : dollar_writeOpType_2 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(1);
    static internal readonly SymbolTerm s2 = SymbolTerm.MakeSymbol("yf");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].Dereference();
        a2 = engine.aregs[2].Dereference();
        Predicate cont = engine.cont;

        if ( !s1.Unify(a1, engine.trail) ) return engine.fail();
        if ( !s2.Unify(a2, engine.trail) ) return engine.fail();
        return cont;
    }
}

sealed class dollar_writeOpType_2_5 : dollar_writeOpType_2 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(2);
    static internal readonly SymbolTerm s2 = SymbolTerm.MakeSymbol("xfx");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].Dereference();
        a2 = engine.aregs[2].Dereference();
        Predicate cont = engine.cont;

        if ( !s1.Unify(a1, engine.trail) ) return engine.fail();
        if ( !s2.Unify(a2, engine.trail) ) return engine.fail();
        return cont;
    }
}

sealed class dollar_writeOpType_2_6 : dollar_writeOpType_2 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(2);
    static internal readonly SymbolTerm s2 = SymbolTerm.MakeSymbol("xfy");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].Dereference();
        a2 = engine.aregs[2].Dereference();
        Predicate cont = engine.cont;

        if ( !s1.Unify(a1, engine.trail) ) return engine.fail();
        if ( !s2.Unify(a2, engine.trail) ) return engine.fail();
        return cont;
    }
}

sealed class dollar_writeOpType_2_7 : dollar_writeOpType_2 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(2);
    static internal readonly SymbolTerm s2 = SymbolTerm.MakeSymbol("yfx");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].Dereference();
        a2 = engine.aregs[2].Dereference();
        Predicate cont = engine.cont;

        if ( !s1.Unify(a1, engine.trail) ) return engine.fail();
        if ( !s2.Unify(a2, engine.trail) ) return engine.fail();
        return cont;
    }
}
}

