/*
 * *** Please do not edit ! ***
 * @(#) dollar_fullLeash_1.cs
 * @procedure $full_leash/1 in interpreter.pl
 */

/*
 * @version P# 1.1.3, on Sept 1 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_fullLeash_1 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.MakeSymbol("call");
    static internal readonly SymbolTerm s2 = SymbolTerm.MakeSymbol("exit");
    static internal readonly SymbolTerm s3 = SymbolTerm.MakeSymbol("redo");
    static internal readonly SymbolTerm s4 = SymbolTerm.MakeSymbol("fail");
    static internal readonly SymbolTerm s5 = SymbolTerm.MakeSymbol("[]");
    static internal readonly ListTerm s6 = new ListTerm(s4, s5);
    static internal readonly ListTerm s7 = new ListTerm(s3, s6);
    static internal readonly ListTerm s8 = new ListTerm(s2, s7);
    static internal readonly ListTerm s9 = new ListTerm(s1, s8);

    public Term arg1;

    public dollar_fullLeash_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public dollar_fullLeash_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1;
        a1 = arg1.Dereference();

        if ( !s9.Unify(a1, engine.trail) ) return engine.fail();
        return cont;
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "$full_leash(" + arg1 + ")";
    }
}
}

