/*
 * *** Please do not edit ! ***
 * @(#) resource_0_Interpreter_dollar_ancestor_2.cs
 * @procedure $res($ancestor/2,0) in interpreter.pl
 */

/*
 * @version P# 1.1.3, on Sept 1 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Resources {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public sealed class resource_0_Interpreter_dollar_ancestor_2 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.MakeSymbol("$reduce", 1);
    public resource_0_Interpreter_dollar_ancestor_2(){}

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        a1 = engine.aregs[1].Dereference();
        a2 = engine.aregs[2].Dereference();
        a3 = engine.aregs[3].Dereference();
        a4 = engine.aregs[4].Dereference();
        Predicate cont = engine.cont;

        if ( a1.IsStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a5 = args[0];
        } else if (a1.IsVariable() ){
            a5 = engine.makeVariable();
            Term[] args = {a5};
            if ( !a1.Unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( !a2.Unify(a3, engine.trail) ) return engine.fail();
        if ( !a5.Unify(a4, engine.trail) ) return engine.fail();
        return cont;
    }

    public override void setArgument( Term[] args, Predicate cont ) { }

    public override int arity() { return 2; }

    public override string ToString() {
        return "dollar_ancestor_2_res0";
    }
}
}

