/*
 * *** Please do not edit ! ***
 * @(#) dollar_assignReg_5.cs
 * @procedure $assign_reg/5 in plcs.pl
 */

/*
 * @version P# 1.1.3, on Sept 1 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_assignReg_5 : Predicate {
    static internal readonly Predicate dollar_assignReg_5_1 = new Predicates.dollar_assignReg_5_1();
    static internal readonly Predicate dollar_assignReg_5_2 = new Predicates.dollar_assignReg_5_2();
    static internal readonly Predicate dollar_assignReg_5_3 = new Predicates.dollar_assignReg_5_3();
    static internal readonly Predicate dollar_assignReg_5_sub_1 = new Predicates.dollar_assignReg_5_sub_1();

    public Term arg1, arg2, arg3, arg4, arg5;

    public dollar_assignReg_5(Term a1, Term a2, Term a3, Term a4, Term a5, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        this.cont = cont;
    }

    public dollar_assignReg_5(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_assignReg_5_1, dollar_assignReg_5_sub_1);
    }

    public override int arity() { return 5; }

    public override string ToString() {
        return "$assign_reg(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ")";
    }
}

sealed class dollar_assignReg_5_sub_1 : dollar_assignReg_5 {
    static internal readonly Predicate dollar_assignReg_5_sub_2 = new Predicates.dollar_assignReg_5_sub_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_assignReg_5_2, dollar_assignReg_5_sub_2);
    }
}

sealed class dollar_assignReg_5_sub_2 : dollar_assignReg_5 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_assignReg_5_3);
    }
}

sealed class dollar_assignReg_5_1 : dollar_assignReg_5 {
    static internal readonly SymbolTerm s1 = SymbolTerm.MakeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15;
        Predicate p1, p2;
        a1 = engine.aregs[1].Dereference();
        a2 = engine.aregs[2].Dereference();
        a3 = engine.aregs[3].Dereference();
        a4 = engine.aregs[4].Dereference();
        a5 = engine.aregs[5].Dereference();
        Predicate cont = engine.cont;

        if ( a4.IsList() ){
            a6 = ((ListTerm)a4).car;
            a7 = ((ListTerm)a4).cdr;
        } else if ( a4.IsVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            if ( !a4.Unify(new ListTerm(a6, a7), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a7.IsList() ){
            a8 = ((ListTerm)a7).car;
            a9 = ((ListTerm)a7).cdr;
        } else if ( a7.IsVariable() ){
            a8 = engine.makeVariable();
            a9 = engine.makeVariable();
            if ( !a7.Unify(new ListTerm(a8, a9), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a9.IsList() ){
            a10 = ((ListTerm)a9).car;
            a11 = ((ListTerm)a9).cdr;
        } else if ( a9.IsVariable() ){
            a10 = engine.makeVariable();
            a11 = engine.makeVariable();
            if ( !a9.Unify(new ListTerm(a10, a11), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a11.IsList() ){
            a12 = ((ListTerm)a11).car;
            if ( !s1.Unify(((ListTerm)a11).cdr, engine.trail) )
                return engine.fail();
        } else if ( a11.IsVariable() ){
            a12 = engine.makeVariable();
            if ( !a11.Unify(new ListTerm(a12, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a5.IsList() ){
            if ( !a6.Unify(((ListTerm)a5).car, engine.trail) )
                return engine.fail();
            if ( !a7.Unify(((ListTerm)a5).cdr, engine.trail) )
                return engine.fail();
        } else if ( a5.IsVariable() ){
            if ( !a5.Unify(new ListTerm(a6, a7), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a7.IsList() ){
            if ( !a8.Unify(((ListTerm)a7).car, engine.trail) )
                return engine.fail();
            if ( !a9.Unify(((ListTerm)a7).cdr, engine.trail) )
                return engine.fail();
        } else if ( a7.IsVariable() ){
            if ( !a7.Unify(new ListTerm(a8, a9), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a9.IsList() ){
            if ( !a10.Unify(((ListTerm)a9).car, engine.trail) )
                return engine.fail();
            if ( !a11.Unify(((ListTerm)a9).cdr, engine.trail) )
                return engine.fail();
        } else if ( a9.IsVariable() ){
            if ( !a9.Unify(new ListTerm(a10, a11), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a11.IsList() ){
            if ( !a12.Unify(((ListTerm)a11).car, engine.trail) )
                return engine.fail();
            if ( !s1.Unify(((ListTerm)a11).cdr, engine.trail) )
                return engine.fail();
        } else if ( a11.IsVariable() ){
            if ( !a11.Unify(new ListTerm(a12, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a13 = engine.makeVariable();
        a15 = new ListTerm(a3, s1);
        a14 = new ListTerm(a2, a15);
        p1 = new Predicates.dollar_cut_1(a13, cont);
        p2 = new Predicates.dollar_allocated_3(a12, a1, a14, p1);
        return new Predicates.dollar_getLevel_1(a13, p2);
    }
}

sealed class dollar_assignReg_5_2 : dollar_assignReg_5 {
    static internal readonly SymbolTerm s1 = SymbolTerm.MakeSymbol("[]");
    static internal readonly SymbolTerm f2 = SymbolTerm.MakeSymbol("s", 1);
    static internal readonly IntegerTerm s4 = new IntegerTerm(1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20, a21, a22, a23;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].Dereference();
        a2 = engine.aregs[2].Dereference();
        a3 = engine.aregs[3].Dereference();
        a4 = engine.aregs[4].Dereference();
        a5 = engine.aregs[5].Dereference();
        Predicate cont = engine.cont;

        if ( a4.IsList() ){
            a6 = ((ListTerm)a4).car;
            a7 = ((ListTerm)a4).cdr;
        } else if ( a4.IsVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            if ( !a4.Unify(new ListTerm(a6, a7), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a7.IsList() ){
            a8 = ((ListTerm)a7).car;
            a9 = ((ListTerm)a7).cdr;
        } else if ( a7.IsVariable() ){
            a8 = engine.makeVariable();
            a9 = engine.makeVariable();
            if ( !a7.Unify(new ListTerm(a8, a9), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a9.IsList() ){
            a10 = ((ListTerm)a9).car;
            a11 = ((ListTerm)a9).cdr;
        } else if ( a9.IsVariable() ){
            a10 = engine.makeVariable();
            a11 = engine.makeVariable();
            if ( !a9.Unify(new ListTerm(a10, a11), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a11.IsList() ){
            a12 = ((ListTerm)a11).car;
            if ( !s1.Unify(((ListTerm)a11).cdr, engine.trail) )
                return engine.fail();
        } else if ( a11.IsVariable() ){
            a12 = engine.makeVariable();
            if ( !a11.Unify(new ListTerm(a12, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a5.IsList() ){
            if ( !a6.Unify(((ListTerm)a5).car, engine.trail) )
                return engine.fail();
            a13 = ((ListTerm)a5).cdr;
        } else if ( a5.IsVariable() ){
            a13 = engine.makeVariable();
            if ( !a5.Unify(new ListTerm(a6, a13), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a13.IsList() ){
            a14 = ((ListTerm)a13).car;
            a15 = ((ListTerm)a13).cdr;
        } else if ( a13.IsVariable() ){
            a14 = engine.makeVariable();
            a15 = engine.makeVariable();
            if ( !a13.Unify(new ListTerm(a14, a15), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a15.IsList() ){
            if ( !a10.Unify(((ListTerm)a15).car, engine.trail) )
                return engine.fail();
            a16 = ((ListTerm)a15).cdr;
        } else if ( a15.IsVariable() ){
            a16 = engine.makeVariable();
            if ( !a15.Unify(new ListTerm(a10, a16), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a16.IsList() ){
            a17 = ((ListTerm)a16).car;
            if ( !s1.Unify(((ListTerm)a16).cdr, engine.trail) )
                return engine.fail();
        } else if ( a16.IsVariable() ){
            a17 = engine.makeVariable();
            if ( !a16.Unify(new ListTerm(a17, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a18 = engine.makeVariable();
        Term[] h3 = {a8};
        a19 = new StructureTerm(f2, h3);
        a23 = new ListTerm(a3, s1);
        a22 = new ListTerm(a2, a23);
        a21 = new ListTerm(a1, a22);
        a20 = new ListTerm(a21, a12);
        p1 = new Predicates.dollar_unify_2(a17, a20, cont);
        p2 = new Predicates.dollar_plus_3(a8, s4, a14, p1);
        p3 = new Predicates.dollar_unify_2(a2, a19, p2);
        p4 = new Predicates.dollar_cut_1(a18, p3);
        p5 = new Predicates.Ground_1(a1, p4);
        return new Predicates.dollar_getLevel_1(a18, p5);
    }
}

sealed class dollar_assignReg_5_3 : dollar_assignReg_5 {
    static internal readonly SymbolTerm s1 = SymbolTerm.MakeSymbol("[]");
    static internal readonly SymbolTerm f2 = SymbolTerm.MakeSymbol("a", 1);
    static internal readonly IntegerTerm s4 = new IntegerTerm(1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20, a21, a22;
        Predicate p1, p2;
        a1 = engine.aregs[1].Dereference();
        a2 = engine.aregs[2].Dereference();
        a3 = engine.aregs[3].Dereference();
        a4 = engine.aregs[4].Dereference();
        a5 = engine.aregs[5].Dereference();
        Predicate cont = engine.cont;

        if ( a4.IsList() ){
            a6 = ((ListTerm)a4).car;
            a7 = ((ListTerm)a4).cdr;
        } else if ( a4.IsVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            if ( !a4.Unify(new ListTerm(a6, a7), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a7.IsList() ){
            a8 = ((ListTerm)a7).car;
            a9 = ((ListTerm)a7).cdr;
        } else if ( a7.IsVariable() ){
            a8 = engine.makeVariable();
            a9 = engine.makeVariable();
            if ( !a7.Unify(new ListTerm(a8, a9), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a9.IsList() ){
            a10 = ((ListTerm)a9).car;
            a11 = ((ListTerm)a9).cdr;
        } else if ( a9.IsVariable() ){
            a10 = engine.makeVariable();
            a11 = engine.makeVariable();
            if ( !a9.Unify(new ListTerm(a10, a11), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a11.IsList() ){
            a12 = ((ListTerm)a11).car;
            if ( !s1.Unify(((ListTerm)a11).cdr, engine.trail) )
                return engine.fail();
        } else if ( a11.IsVariable() ){
            a12 = engine.makeVariable();
            if ( !a11.Unify(new ListTerm(a12, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a5.IsList() ){
            a13 = ((ListTerm)a5).car;
            a14 = ((ListTerm)a5).cdr;
        } else if ( a5.IsVariable() ){
            a13 = engine.makeVariable();
            a14 = engine.makeVariable();
            if ( !a5.Unify(new ListTerm(a13, a14), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a14.IsList() ){
            if ( !a8.Unify(((ListTerm)a14).car, engine.trail) )
                return engine.fail();
            a15 = ((ListTerm)a14).cdr;
        } else if ( a14.IsVariable() ){
            a15 = engine.makeVariable();
            if ( !a14.Unify(new ListTerm(a8, a15), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a15.IsList() ){
            if ( !a10.Unify(((ListTerm)a15).car, engine.trail) )
                return engine.fail();
            a16 = ((ListTerm)a15).cdr;
        } else if ( a15.IsVariable() ){
            a16 = engine.makeVariable();
            if ( !a15.Unify(new ListTerm(a10, a16), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a16.IsList() ){
            a17 = ((ListTerm)a16).car;
            if ( !s1.Unify(((ListTerm)a16).cdr, engine.trail) )
                return engine.fail();
        } else if ( a16.IsVariable() ){
            a17 = engine.makeVariable();
            if ( !a16.Unify(new ListTerm(a17, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        Term[] h3 = {a6};
        a18 = new StructureTerm(f2, h3);
        a22 = new ListTerm(a3, s1);
        a21 = new ListTerm(a2, a22);
        a20 = new ListTerm(a1, a21);
        a19 = new ListTerm(a20, a12);
        p1 = new Predicates.dollar_unify_2(a17, a19, cont);
        p2 = new Predicates.dollar_plus_3(a6, s4, a13, p1);
        return new Predicates.dollar_unify_2(a2, a18, p2);
    }
}
}

