/*
 * *** Please do not edit ! ***
 * @(#) dollar_genPutCont_6.cs
 * @procedure $gen_put_cont/6 in plcs.pl
 */

/*
 * @version P# 1.1.3, on Sept 1 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_genPutCont_6 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.MakeSymbol("[]");
    static internal readonly SymbolTerm f2 = SymbolTerm.MakeSymbol("p", 1);
    static internal readonly IntegerTerm s4 = new IntegerTerm(1);
    static internal readonly SymbolTerm f5 = SymbolTerm.MakeSymbol("put_cont", 2);

    public Term arg1, arg2, arg3, arg4, arg5, arg6;

    public dollar_genPutCont_6(Term a1, Term a2, Term a3, Term a4, Term a5, Term a6, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        arg6 = a6; 
        this.cont = cont;
    }

    public dollar_genPutCont_6(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        arg6 = args[5]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18;
        Predicate p1, p2;
        a1 = arg1.Dereference();
        a2 = arg2.Dereference();
        a3 = arg3.Dereference();
        a4 = arg4.Dereference();
        a5 = arg5.Dereference();
        a6 = arg6.Dereference();

        if ( a3.IsList() ){
            a7 = ((ListTerm)a3).car;
            a8 = ((ListTerm)a3).cdr;
        } else if ( a3.IsVariable() ){
            a7 = engine.makeVariable();
            a8 = engine.makeVariable();
            if ( !a3.Unify(new ListTerm(a7, a8), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a8.IsList() ){
            a9 = ((ListTerm)a8).car;
            a10 = ((ListTerm)a8).cdr;
        } else if ( a8.IsVariable() ){
            a9 = engine.makeVariable();
            a10 = engine.makeVariable();
            if ( !a8.Unify(new ListTerm(a9, a10), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a10.IsList() ){
            a11 = ((ListTerm)a10).car;
            a12 = ((ListTerm)a10).cdr;
        } else if ( a10.IsVariable() ){
            a11 = engine.makeVariable();
            a12 = engine.makeVariable();
            if ( !a10.Unify(new ListTerm(a11, a12), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a12.IsList() ){
            a13 = ((ListTerm)a12).car;
            if ( !s1.Unify(((ListTerm)a12).cdr, engine.trail) )
                return engine.fail();
        } else if ( a12.IsVariable() ){
            a13 = engine.makeVariable();
            if ( !a12.Unify(new ListTerm(a13, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a4.IsList() ){
            if ( !a7.Unify(((ListTerm)a4).car, engine.trail) )
                return engine.fail();
            a14 = ((ListTerm)a4).cdr;
        } else if ( a4.IsVariable() ){
            a14 = engine.makeVariable();
            if ( !a4.Unify(new ListTerm(a7, a14), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a14.IsList() ){
            if ( !a9.Unify(((ListTerm)a14).car, engine.trail) )
                return engine.fail();
            a15 = ((ListTerm)a14).cdr;
        } else if ( a14.IsVariable() ){
            a15 = engine.makeVariable();
            if ( !a14.Unify(new ListTerm(a9, a15), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a15.IsList() ){
            a16 = ((ListTerm)a15).car;
            if ( !a12.Unify(((ListTerm)a15).cdr, engine.trail) )
                return engine.fail();
        } else if ( a15.IsVariable() ){
            a16 = engine.makeVariable();
            if ( !a15.Unify(new ListTerm(a16, a12), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a12.IsList() ){
            if ( !a13.Unify(((ListTerm)a12).car, engine.trail) )
                return engine.fail();
            if ( !s1.Unify(((ListTerm)a12).cdr, engine.trail) )
                return engine.fail();
        } else if ( a12.IsVariable() ){
            if ( !a12.Unify(new ListTerm(a13, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        Term[] h3 = {a11};
        a17 = new StructureTerm(f2, h3);
        Term[] h6 = {a1, a2};
        a18 = new StructureTerm(f5, h6);
        p1 = new Predicates._C_3(a5, a18, a6, cont);
        p2 = new Predicates.dollar_plus_3(a11, s4, a16, p1);
        return new Predicates.dollar_unify_2(a2, a17, p2);
    }

    public override int arity() { return 6; }

    public override string ToString() {
        return "$gen_put_cont(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ", " + arg6 + ")";
    }
}
}

