/*
 * *** Please do not edit ! ***
 * @(#) dollar_wjGetListRead_3.cs
 * @procedure $wj_get_list_read/3 in plcs.pl
 */

/*
 * @version P# 1.1.3, on Sept 1 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_wjGetListRead_3 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.MakeSymbol("[]");
    static internal readonly SymbolTerm s2 = SymbolTerm.MakeSymbol("car");
    static internal readonly SymbolTerm s3 = SymbolTerm.MakeSymbol("cdr");

    public Term arg1, arg2, arg3;

    public dollar_wjGetListRead_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_wjGetListRead_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1;
        a1 = arg1.Dereference();
        a2 = arg2.Dereference();
        a3 = arg3.Dereference();

        if ( a3.IsList() ){
            a4 = ((ListTerm)a3).car;
            a5 = ((ListTerm)a3).cdr;
        } else if ( a3.IsVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            if ( !a3.Unify(new ListTerm(a4, a5), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a5.IsList() ){
            a6 = ((ListTerm)a5).car;
            if ( !s1.Unify(((ListTerm)a5).cdr, engine.trail) )
                return engine.fail();
        } else if ( a5.IsVariable() ){
            a6 = engine.makeVariable();
            if ( !a5.Unify(new ListTerm(a6, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_unifyListR_4(a1, s3, a2, a6, cont);
        return new Predicates.dollar_unifyListR_4(a1, s2, a2, a4, p1);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$wj_get_list_read(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}
}

