/*
 * *** Please do not edit ! ***
 * @(#) Plcomp_1.cs
 * @procedure plcomp/1 in plcs.pl
 */

/*
 * @version P# 1.1.3, on Sept 1 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Plcomp_1 : Predicate {
    static internal readonly Predicate Plcomp_1_1 = new Predicates.Plcomp_1_1();
    static internal readonly Predicate Plcomp_1_2 = new Predicates.Plcomp_1_2();
    static internal readonly Predicate Plcomp_1_sub_1 = new Predicates.Plcomp_1_sub_1();

    public Term arg1;

    public Plcomp_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public Plcomp_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(Plcomp_1_1, Plcomp_1_sub_1);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "plcomp(" + arg1 + ")";
    }
}

sealed class Plcomp_1_sub_1 : Plcomp_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(Plcomp_1_2);
    }
}

sealed class Plcomp_1_1 : Plcomp_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.MakeSymbol("$compile_to_writer", 1);
    static internal readonly SymbolTerm s3 = SymbolTerm.MakeSymbol("System.IO.StringWriter");
    static internal readonly SymbolTerm f5 = SymbolTerm.MakeSymbol("GetStringBuilder", 1);
    static internal readonly SymbolTerm f7 = SymbolTerm.MakeSymbol("ToString", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8;
        a1 = engine.aregs[1].Dereference();
        Predicate cont = engine.cont;

        Term[] h2 = {engine.makeVariable()};
        a2 = new StructureTerm(f1, h2);
        a3 = engine.makeVariable();
        Term[] h4 = {a3};
        a4 = new StructureTerm(f1, h4);
        a6 = engine.makeVariable();
        Term[] h6 = {a6};
        a5 = new StructureTerm(f5, h6);
        a8 = engine.makeVariable();
        Term[] h8 = {a8};
        a7 = new StructureTerm(f7, h8);
        a9 = engine.makeVariable();
        Term[] h9 = {engine.makeVariable()};
        a10 = new StructureTerm(f1, h9);
        p1 = new Predicates.Retractall_1(a10, cont);
        p2 = new Predicates.dollar_loadAssembly_1(a9, p1);
        p3 = new Predicates.dollar_csc_2(a8, a9, p2);
        p4 = new Predicates.colon_2(a6, a7, p3);
        p5 = new Predicates.colon_2(a3, a5, p4);
        p6 = new Predicates.Plcs_1(a1, p5);
        p7 = new Predicates.Assert_1(a4, p6);
        p8 = new Predicates.dollar_csConstructor_2(s3, a3, p7);
        return new Predicates.Retractall_1(a2, p8);
    }
}

sealed class Plcomp_1_2 : Plcomp_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.MakeSymbol("$compile_to_writer", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        Predicate p1;
        a1 = engine.aregs[1].Dereference();
        Predicate cont = engine.cont;

        Term[] h2 = {engine.makeVariable()};
        a2 = new StructureTerm(f1, h2);
        p1 = new Predicates.dollar_fail_0(cont);
        return new Predicates.Retractall_1(a2, p1);
    }
}
}

