/*
 * @(#)Stop_1.cs
 * Prolog predicate stop/1
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class Stop_1 : Predicate {
		Term arg1;

		public Stop_1(Term a1, Predicate cont) {
			arg1 = a1;
			this.cont = cont;
		}
		public Stop_1() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1 = arg1.Dereference( );
			if( !a1.IsCsObject( ) ) 
				return engine.fail( );
			CsObjectTerm cso = (CsObjectTerm)a1;
			object o = cso.Object( );
			if( !( o is PrologInterface ) )
				return engine.fail( );
			PrologInterface pi = (PrologInterface)o;
			pi.Stop( );
			return cont;
		}

		public override int arity() { return 1; }
		public override string ToString() {
			return "$stop(" + arg1 + ")";
		}	
	}

}