/*
 * @(#)dollar_copyTerm_2.cs
 * Prolog predicate $copy_term/2 (copy_term/2)
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_copyTerm_2 : Predicate {
		Term arg1, arg2;

		public dollar_copyTerm_2(Term a1, Term a2, Predicate cont) {
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}
		public dollar_copyTerm_2() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term copy;
			Term a1, a2;
			a1 = arg1.Dereference();
			a2 = arg2.Dereference();

			copy = engine.CopyTerm(a1);
			if( !a2.Unify(copy, engine.trail) )
				return engine.fail();
			return cont;    
		}

		public override int arity() { return 2; }

		public override string ToString() {
			return "$copy_term(" + arg1 + ", " + arg2 + ")";
		}
	}

}