/*
 * @(#)dollar_csTerm_2.cs
 * Prolog predicate $cs_term/2 (cs_term/2)
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_csTerm_2 : Predicate {
		Term arg1, arg2;

		public dollar_csTerm_2(Term a1, Term a2, Predicate cont) {
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}
		public dollar_csTerm_2() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1, a2;
			a1 = arg1.Dereference(); // Prolog Term
			a2 = arg2.Dereference(); // C# Term

			Term pterm, jterm;
			if ( a1.IsVariable() ){
				if ( ! a2.IsCsObject() )
					return engine.fail();
				pterm = ((CsObjectTerm)a2).ToPrologTerm();
				if ( ! a1.Unify(pterm, engine.trail) )
					return engine.fail();
				return cont;
			}
			if ( a2.IsVariable() ){
				jterm = new CsObjectTerm(a1.ToCsObject());
				if ( ! a2.Unify(jterm, engine.trail) )
					return engine.fail();
				return cont;
			}

			if ( ! a2.IsCsObject() )
				return engine.fail();
			pterm = ((CsObjectTerm)a2).ToPrologTerm();
			jterm = new CsObjectTerm(a1.ToCsObject());
			if ( ! pterm.Unify(jterm, engine.trail) )
				return engine.fail();
			return cont;
		}

		public override int arity() { return 2; }
		public override string ToString() {
			return "$cs_term(" + arg1 + "," + arg2 + ")";
		}
	}

}