/*
 * @(#)dollar_fastWriteq_2.cs
 * Prolog predicate $fast_writeq/2
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	using System.IO;

	public sealed class dollar_fastWriteq_2 : Predicate {
		Term arg1, arg2;

		public dollar_fastWriteq_2(Term a1, Term a2, Predicate cont) {
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}
		public dollar_fastWriteq_2() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1, a2;
			a1 = arg1.Dereference();
			a2 = arg2.Dereference();
			object obj;

			if ( !a1.IsCsObject() ) {
				return engine.abort("{TYPE ERROR: " + this + 
					" - arg 1: expected stream, found " +
					a1 + "}");
				//	    return null;
			}
			obj = ((CsObjectTerm)a1).Object();
			if ( !(obj is TextWriter) ) {
				return engine.abort("{TYPE ERROR: " + this + 
					" - arg 1: expected stream, found " +
					a1 + "}");
				//	    return null;
			}
			Token.Writeq_string(a1.ToString(), ((TextWriter)obj));
			return cont;
		}

		public override int arity() { return 2; }

		public override string ToString() {
			return "$fast_writeq(" + arg1 + ", " + arg2 + ")";
		}
	}

}