/*
 * @(#)dollar_getLevel_1.cs
 * Prolog predicate $get_level/1
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_getLevel_1 : Predicate {
		Term arg1;

		public dollar_getLevel_1(Term a1, Predicate cont) {
			arg1 = a1;
			this.cont = cont;
		}
		public dollar_getLevel_1() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1;
			a1 = arg1.Dereference();

			if( !a1.Unify(new IntegerTerm(engine.B0), engine.trail) ) 
				return engine.fail();
			return cont;    
		}

		public override int arity() { return 1; }
		public override string ToString() {
			return "$get_level(" + arg1 + ")";
		}
	}

}