/*
 * @(#)dollar_integer_1.cs
 * Prolog predicate $integer/1
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_integer_1 : Predicate {
		Term arg1;

		public dollar_integer_1(Term a1, Predicate cont) {
			arg1 = a1;
			this.cont = cont;
		}
		public dollar_integer_1() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1;
			a1 = arg1.Dereference();

			if( !a1.IsInteger() ) 
				return engine.fail();
			return cont;
		}

		public override int arity() { return 1 ; }
		public override string ToString() {
			return "$integer(" + arg1 + ")";
		}
	}

}