/*
 * @(#)dollar_lock_2.cs
 * Prolog predicate $lock/2
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_lock_2 : Predicate {
		Term arg1;
		Term arg2;

		public dollar_lock_2(Term a1, Term a2, Predicate cont) {
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}
		public dollar_lock_2() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1 = arg1.Dereference( );
			Term a2 = arg2.Dereference( );
			object to_lock;

			if( a1.IsVariable( ) )
				if( ( (VariableTerm)a1 ).concurrentRoot != null )
					a1 = ( (VariableTerm)a1 ).concurrentRoot.csObject;
			if( a1.IsCsObject( ) ) 
				to_lock = a1.ToCsObject( );
			else
				to_lock = a1;
			
			if( !a2.IsVariable( ) )
				return engine.fail( );

			if( !( a2.Unify( new IntegerTerm( 0 ), engine.trail ) ))
				return engine.fail( );
			( (VariableTerm)a2 ).locked_object = to_lock;

			System.Threading.Monitor.Enter( to_lock );
			engine.ReportLock( to_lock );

			return cont;
		}

		public override int arity() { return 1; }
		public override string ToString() {
			return "$lock(" + arg1 + ")";
		}	
	}

}