/*
 * @(#)dollar_pow_3.cs
 * Prolog predicate $pow/3
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_pow_3 : Predicate {
		Term arg1, arg2, arg3;

		public dollar_pow_3(Term a1, Term a2, Term a3, Predicate cont){
			arg1 = a1;
			arg2 = a2;
			arg3 = a3;
			this.cont = cont;
		}
		public dollar_pow_3(){}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			arg3 = args[2];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ){
			Term a3;
			double d1, d2;
			
			a3 = arg3.Dereference();
			try {
				d1 = engine.DoubleValue( arg1 );
				d2 = engine.DoubleValue( arg2 );
			} catch (ArithException) {
				return engine.abort("{TYPE ERROR: " + this + "}\n");
			}
			if(!a3.Unify(new DoubleTerm( System.Math.Pow( d1, d2 ) ), engine.trail)) 
				return engine.fail();
			return cont;
		}

		public override int arity() { return 3; }

		public override string ToString() {
			return "$pow(" + arg1 + "," + arg2 + "," + arg3 + ")";
		}
	}

}