/*
 * @(#)dollar_protectedUnify_2.cs
 * Prolog predicate $protected_unify/2
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_protectedUnify_2 : Predicate {
		Term arg1, arg2;

		public dollar_protectedUnify_2(Term a1, Term a2, Predicate cont) {
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}
		public dollar_protectedUnify_2() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1, a2;
			a1 = arg1.Dereference();
			a2 = arg2.Dereference();
	
			if( !a1.IsVariable( ) ) {
				if( !a1.Unify(a2, engine.trail) ) 
					return engine.fail();
			} else {
				VariableTerm vt = (VariableTerm)a1;
				if( !vt.OldUnify( a2, engine.trail ) )
					return engine.fail( );
			}
			return cont;
		}

		public override int arity() { return 2; }
		public override string ToString() {
			return "$protected_unify(" + arg1 + ", " + arg2 + ")";
		}
	}

}