/*
 * @(#) dollar_put_2.cs
 * Prolog predicate $put/2
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	using System.IO;

	public sealed class dollar_put_2 : Predicate {
		private static SymbolTerm SYM_user = SymbolTerm.MakeSymbol("user");
		private static SymbolTerm SYM_user_output = SymbolTerm.MakeSymbol("user_output");
		Term arg1, arg2;

		public dollar_put_2(Term a1, Term a2, Predicate cont) {
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}
		public dollar_put_2() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1;
			a1 = arg1.Dereference();
			object obj;
			char ch;

			try {
				ch = (char)(engine.DoubleValue(arg2));
			} catch (ArithException) {
				return engine.abort("{TYPE ERROR: " + this + 
					" - arg 2: expected expression, found " +
					arg2 + "}");
				//	    return null;
			}
			if ( a1.IsVariable() ) {
				return engine.abort("{INSTANTIATION  ERROR: " + this + 
					" -arg 1: expected stream, found " +
					a1 + "}\n");
				//	    return null;
			}
			if ( a1.Equals(SYM_user) || a1.Equals(SYM_user_output) ) {
				engine.current_output.Write(ch);
				return cont;
			}
			if ( !a1.IsCsObject() ) {
				return engine.abort("{TYPE ERROR: " + this + 
					" - arg 1: expected stream, found " +
					a1 + "}");
				//	    return null;
			}
			obj = ((CsObjectTerm)a1).Object();
			if ( !(obj is TextWriter) ) {
				return engine.abort("{TYPE ERROR: " + this + 
					" - arg 1: expected stream, found " +
					a1 + "}");
				//	    return null;
			}
			((TextWriter)obj).Write(ch);
			return cont;
		}

		public override int arity() { return 2; }
		public override string ToString() {
			return "$put(" + arg1 + ", " + arg2 + ")";
		}
	}

}