/*
 * @(#)dollar_radians_2.cs
 * Prolog predicate $radians/2
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_radians_2 : Predicate {
		Term arg1, arg2;

		public dollar_radians_2(Term a1, Term a2, Predicate cont){
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}
		public dollar_radians_2(){}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ){
			Term a2;
			double d;
			
			a2 = arg2.Dereference();
			try {
				d = engine.DoubleValue( arg1 );
			} catch (ArithException) {
				return engine.abort("{TYPE ERROR: " + this + "}\n");
			}
			if(!a2.Unify(new DoubleTerm( d / 180.0 * System.Math.PI), engine.trail)) 
				return engine.fail();
			return cont;
		}

		public override int arity() { return 2; }

		public override string ToString() {
			return "$radians(" + arg1 + "," + arg2 + ")";
		}
	}

}