/*
 * @(#) dollar_setTable_1.cs
 * Prolog predicate $set_table/1
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	using System.Collections;

	public sealed class dollar_setTable_1 : Predicate {
		private static SymbolTerm SYM_user = SymbolTerm.MakeSymbol("user");
		Term arg1;

		public dollar_setTable_1(Term a1, Predicate cont) {
			arg1 = a1;
			this.cont = cont;
		}
		public dollar_setTable_1() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1;
			a1 = arg1.Dereference();
			object obj;
	
			if ( a1.IsVariable() ) {
				return engine.abort("{INSTANTIATION  ERROR: " + this + "}\n");
			}
			if ( a1.Equals(SYM_user) ) {
				engine.setTable(engine.user_table);
				return cont;
			}
			if ( !a1.IsCsObject() ) { 
				return engine.abort("{TYPE ERROR: " + this + 
					" - arg 1: expected table, found " +
					a1 + "}");
			}
			obj = ((CsObjectTerm)a1).Object();
			if ( !(obj is Hashtable) ) {
				return engine.abort("{TYPE ERROR: " + this + 
					" - arg 1: expected table, found " +
					a1 + "}");
			}
			engine.setTable((Hashtable)obj);
			return cont;
		}

		public override int arity() { return 1; }
		public override string ToString() {
			return "$set_table(" + arg1 + ")";
		}
	}

}