/*
 * @(#)dollar_toFloat_2.cs
 * Prolog predicate $to_float/2
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_toFloat_2 : Predicate {
		Term arg1, arg2;

		public dollar_toFloat_2(Term a1, Term a2, Predicate cont){
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}
		public dollar_toFloat_2(){}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ){
			Term a1,a2;
			Term num;

			a2 = arg2.Dereference();
			try {
				a1 = engine.EvalTerm(arg1);
				if (a1.IsInteger()) {
					double x = ((IntegerTerm)a1).DoubleValue();
					num = new DoubleTerm(x);
				} else if (a1.IsDouble()) {
					num = a1;
				} else {
					return engine.fail();
				}
			} catch (PrologException) {
				return engine.abort("{TYPE ERROR: " + this + "}\n");		
			}
			if(!a2.Unify(num, engine.trail)) 
				return engine.fail();
			return cont;
		}

		public override int arity() { return 2; }

		public override string ToString() {
			return "$to_float(" + arg1 + "," + arg2 + ")";
		}
	}

}