/*
 * @(#)dollar_toInteger_2.cs
 * Prolog predicate $to_integer/2
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_toInteger_2 : Predicate {
		Term arg1, arg2;

		public dollar_toInteger_2(Term a1, Term a2, Predicate cont){
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}
		public dollar_toInteger_2(){}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec(Prolog engine){
			Term a1,a2;
			Term num;

			a2 = arg2.Dereference();
			try {
				a1 = engine.EvalTerm(arg1);
				if (a1.IsInteger()) {
					num = a1;
				} else if (a1.IsDouble()) {
					int x = ((DoubleTerm)a1).IntValue();
					num = new IntegerTerm(x);
				} else {
					return engine.fail();
				}
			} catch (ArithException) {
				return engine.abort("{TYPE ERROR: " + this +  "}\n");
			}
			if(!a2.Unify(num, engine.trail)) 
				return engine.fail();
			return cont;
		}

		public override int arity() { return 2; }
		public override string ToString() {
			return "$to_integer(" + arg1 + "," + arg2 + ")";
		}
	}

}