/*
 * @(#) dollar_unget_2.cs
 * Prolog predicate $unget/2
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_unget_2 : Predicate {
		private static SymbolTerm SYM_user = SymbolTerm.MakeSymbol("user");
		private static SymbolTerm SYM_user_input = SymbolTerm.MakeSymbol("user_input");
		Term arg1, arg2;

		public dollar_unget_2(Term a1, Term a2, Predicate cont) {
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}
		public dollar_unget_2() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1, a2;
			a1 = arg1.Dereference();
			a2 = arg2.Dereference();
			object obj;
			int val;

			if ( !a2.IsInteger() )
				return engine.fail();
			val = ((IntegerTerm)a2).value();

			if ( a1.IsVariable() ) {
				return engine.abort("{INSTANTIATION  ERROR: " + this + 
					" -arg 1: expected stream, found " +
					a1 + "}\n");
			}
			if ( a1.Equals(SYM_user) || a1.Equals(SYM_user_input) ) {
				try { 
					engine.user_input.Unread(val);
				} catch (System.Exception) {
					return engine.abort("{IO Error: " + this + "}");
				}
				return cont;
			}
			if ( !a1.IsCsObject() ) {
				return engine.abort("{TYPE ERROR: " + this + 
					" - arg 1: expected stream, found " +
					a1 + "}");
			}
			obj = ((CsObjectTerm)a1).Object();
			if ( !(obj is PushbackReader) ) {
				return engine.abort("{TYPE ERROR: " + this + 
					" - arg 1: expected stream, found " +
					a1 + "}");
			}
			try { 
				((PushbackReader)obj).Unread(val);
			} catch (System.Exception) {
				return engine.abort("{IO Error: " + this + "}\n");
			}
			return cont;
		}

		public override int arity() { return 2; }
		public override string ToString() {
			return "$unget(" + arg1 + ", " + arg2 + ")";
		}
	}

}