/*
 * @(#)dollar_unlock/1.cs
 * Prolog predicate $unlock/1
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_unlock_1 : Predicate {
		Term arg1;

		public dollar_unlock_1(Term a1, Predicate cont) {
			arg1 = a1;
			this.cont = cont;
		}
		public dollar_unlock_1() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1 = arg1.Dereference( );
			if( a1.IsVariable( ) )
				if( ( (VariableTerm)a1 ).concurrentRoot != null )
					a1 = ( (VariableTerm)a1 ).concurrentRoot.csObject;
			object to_unlock;
			if( a1.IsCsObject( ) ) 
				to_unlock = a1.ToCsObject( );
			else
				to_unlock = a1;
			System.Threading.Monitor.Exit( a1.ToCsObject( ) );
			engine.ReportUnlock( a1.ToCsObject( ) );
			return cont;
		}

		public override int arity() { return 1; }
		public override string ToString() {
			return "$unlock(" + arg1 + ")";
		}	
	}

}