/*
 * @(#)dollar_urlSource_2.java
 * Prolog predicate $url_source/2
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;
	using System;
	using System.IO;
	using System.Net;

	public sealed class dollar_urlSource_2 : Predicate {
		Term arg1, arg2;

		public dollar_urlSource_2(Term a1, Term a2, Predicate cont) {
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}
		public dollar_urlSource_2() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1, a2;
			a1 = arg1.Dereference();
			a2 = arg2.Dereference();

			if ( !a1.IsSymbol() )
				return engine.abort("{TYPE ERROR: " + this +
					" expected URL expression (e.g http:// ....), found " + 
					a1 + "}\n");
			if ( !a2.IsVariable() )
				return engine.abort("{TYPE ERROR: " + this +
					" expected unbound variable, found " + 
					a1 + "}\n");

			string s = "";			
			TextReader cin = null;

			try {
				WebRequest request = System.Net.WebRequest.Create( a1.ToString( ) );
				WebResponse response = request.GetResponse( );
				Stream stream = response.GetResponseStream( );
				cin = new System.IO.StreamReader( stream );
				string tmp = "";
				tmp = cin.ReadLine();
				while (tmp != null){
					s += tmp;
					tmp = cin.ReadLine();
				}
			}
				/*
			catch (MalformedURLException e1){ 
				return engine.fail();
				//e1.printStackTrace(); 
			}
			catch (IOException e2){	
				return engine.fail();
				//e2.printStackTrace(); 
			}
			*/
			catch (Exception){ 
				return engine.fail();
				//e.printStackTrace(); 
			}
			finally {
				try {
					cin.Close();
				}
				catch (Exception){}
			}

			if ( !a2.Unify(SymbolTerm.MakeSymbol(s), engine.trail) )
				return engine.fail();
			return cont;
		}

		public override int arity() { return 2; }

		public override string ToString() {
			return "$url_source(" + arg1 + "," + arg2 + ")";
		}
	}

}