/*
 *  @(#)Predicate.cs 
 */

/* 
 * @author Mutsunori Banbara 
 *         banbara@pascal.seg.kobe-u.ac.jp
 *         Nara National College of Technology
 * @author Naoyuki Tamura 
 *         tamura@kobe-u.ac.jp
 *         Kobe University
 * Modified by Jon Cook.
 */

namespace JJC.Psharp.Lang {

	public interface FcoPredicate {
		Predicate call( Prolog engine );
	}

	public abstract class Predicate {
		protected Predicate cont = null;

		abstract public Predicate exec( Prolog engine );
		
		abstract public int arity();
		
		abstract public void setArgument(Term[] args, Predicate cont);
	}
}