namespace JJC.Psharp.Lang {

	using System.IO;

	/// <summary>
	/// Reader with ability to unread back two chars.
	/// </summary>
	public class PushbackReader {
		
		int[] buffer = new int[2];
		int position = 0;
		TextReader t;

		public PushbackReader( TextReader t ) {
			this.t = t;
		}
		
		public virtual int Read( ) {
			lock( this ) {
				if( position == 2 ) {
					position = 1;
					return buffer[1];
				} else if( position == 1 ) {
					position = 0;
					return buffer[0];
				} else
					return t.Read( );
			}
		}

		public virtual void Unread( int c ) {
			lock( this ) {
				if( position == 2 ) {
					throw new System.Exception( "cannot unread" );
				} else if( position == 1 ) {
					buffer[1] = c;
					position = 2;
				} else {
					buffer[0] = c;
					position = 1;
				}
			}
		}
		
		public virtual void Close( ) {
			lock( this ) {
				t.Close( );
			}
		}
	}
}