/* 
 *  @(#)ResIndexTerm.cs
 */

/* 
 * @author Mutsunori Banbara 
 *         banbara@pascal.seg.kobe-u.ac.jp
 *         Nara National College of Technology
 * @author Naoyuki Tamura 
 *         tamura@kobe-u.ac.jp
 *         Kobe University
 * Modified by Jon Cook.
 */

namespace JJC.Psharp.Lang.Resource {

	using JJC.Psharp.Lang;

	public sealed class ResIndexTerm : Term {
		private int index;

		public ResIndexTerm(int i) { index = i; }

		public int getIndex() { return index; }

		public override bool Unify(Term t, Trail trail) {
			t = t.Dereference();
			if ( t.IsVariable() )
				return ((VariableTerm)t).Unify(this, trail);
			if ( !t.IsResIndex() )
				return false;
			return index == ((ResIndexTerm)t).getIndex();
		}

		public override bool Equals(Term t) {
			//	t = t.Dereference();
			if( !t.IsResIndex() )
				return false;
			return index == ((ResIndexTerm)t).getIndex();
		}

		//    public Term CopyTerm(Hashtable table) {
		//	return new ResIndexTerm(index);
		//    }

		public override Term CopyTerm(Prolog engine) {
			return new ResIndexTerm(index);
		}

		/*
		public Class getJavaType() {
		return java.lang.Integer.TYPE;
		}*/
		public override object ToCsObject() {
			return index;
		}

		public override string ToString() {
			return index.ToString();
		}
	}

}