/*
 *  @(#)dollar_endExpImp_2.cs
 * Prolog predicate $end_exp_imp/2
 */

/* 
 * @author Mutsunori Banbara 
 *         banbara@pascal.seg.kobe-u.ac.jp
 *         Nara National College of Technology
 * @author Naoyuki Tamura 
 *         tamura@kobe-u.ac.jp
 *         Kobe University
 * Modified by Jon Cook.
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;
	using JJC.Psharp.Lang.Resource;

	public sealed class dollar_endExpImp_2 : Predicate {
		Term arg1, arg2;

		public dollar_endExpImp_2(Term a1, Term a2, Predicate cont) {
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}
		public dollar_endExpImp_2() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1, a2;
			a1 = arg1.Dereference();
			a2 = arg2.Dereference();

			if ( !a1.IsResIndex() || !a2.IsResIndex() ){
				return engine.abort("{TYPE ERROR: " + this + "}\n");
				//	    return engine.fail();
			}
			engine.endExpImp((ResIndexTerm)a1, (ResIndexTerm)a2);
			return cont;
		}

		public override int arity() { return 2; }
		public override string ToString() {
			return "$end_exp_imp(" + arg1 + ", " + arg2 + ")";
		}
	}

}