/*
 *  @(#) dollar_endWith_0.cs
 * Prolog predicate $end_with/0
 */

/* 
 * @author Mutsunori Banbara 
 *         banbara@pascal.seg.kobe-u.ac.jp
 *         Nara National College of Technology
 * @author Naoyuki Tamura 
 *         tamura@kobe-u.ac.jp
 *         Kobe University
 * Modified by Jon Cook.
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_endWith_0 : Predicate {

		public dollar_endWith_0(Predicate cont) {
			this.cont = cont;
		}
		public dollar_endWith_0() {}
		public override void setArgument(Term[] args, Predicate cont){
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			if ( !engine.endWith() )
				return engine.fail();
			return cont;
		}

		public override int arity() { return 0; }
		public override string ToString() {
			return "$end_with";
		}
	}

}