/*
 *  @(#) dollar_midWith_0.cs
 * Prolog predicate $mid_with/0
 */

/* 
 * @author Mutsunori Banbara 
 *         banbara@pascal.seg.kobe-u.ac.jp
 *         Nara National College of Technology
 * @author Naoyuki Tamura 
 *         tamura@kobe-u.ac.jp
 *         Kobe University
 * Modified by Jon Cook.
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_midWith_0 : Predicate {

		public dollar_midWith_0(Predicate cont) {
			this.cont = cont;
		}
		public dollar_midWith_0() {}
		public override void setArgument(Term[] args, Predicate cont){
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			engine.midWith();
			return cont;
		}

		public override int arity() { return 0; }
		public override string ToString() {
			return "$mid_with";
		}
	}

}