/*
 * *** Please do not edit ! ***
 * @(#) DesignPrime_3.cs
 * @procedure design_prime/3 in mltoprolog.pl
 */

/*
 * @version P# 1.1.3, on Sept 1 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class DesignPrime_3 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.MakeSymbol("node", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.MakeSymbol("pair", 2);
    static DoubleTerm s3 = new DoubleTerm(0);
    static internal readonly SymbolTerm s4 = SymbolTerm.MakeSymbol("movetree");
    static internal readonly SymbolTerm s5 = SymbolTerm.MakeSymbol("moveextent");
    static internal readonly SymbolTerm s6 = SymbolTerm.MakeSymbol("[]");

    public Term arg1, arg2, arg3;

    public DesignPrime_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public DesignPrime_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20;
        Predicate p1, p2, p3, p4, p5, p6, p7;
        a1 = arg1.Dereference();
        a2 = arg2.Dereference();
        a3 = arg3.Dereference();

        if ( a1.IsStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a4 = args[0];
            a5 = args[1];
        } else if (a1.IsVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            Term[] args = {a4, a5};
            if ( !a1.Unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a3.IsStructure() ){
            if (f2 != ((StructureTerm)a3).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a3).args;
            a6 = args[0];
            a7 = args[1];
        } else if (a3.IsVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            Term[] args = {a6, a7};
            if ( !a3.Unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a6.IsStructure() ){
            if (f1 != ((StructureTerm)a6).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a6).args;
            a8 = args[0];
            a9 = args[1];
        } else if (a6.IsVariable() ){
            a8 = engine.makeVariable();
            a9 = engine.makeVariable();
            Term[] args = {a8, a9};
            if ( !a6.Unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a8.IsStructure() ){
            if (f2 != ((StructureTerm)a8).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a8).args;
            if ( !a4.Unify(args[0],  engine.trail) )
                return engine.fail();
            if ( !s3.Unify(args[1],  engine.trail) )
                return engine.fail();
        } else if (a8.IsVariable() ){
            Term[] args = {a4, s3};
            if ( !a8.Unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a7.IsList() ){
            a10 = ((ListTerm)a7).car;
            a11 = ((ListTerm)a7).cdr;
        } else if ( a7.IsVariable() ){
            a10 = engine.makeVariable();
            a11 = engine.makeVariable();
            if ( !a7.Unify(new ListTerm(a10, a11), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a12 = engine.makeVariable();
        a13 = engine.makeVariable();
        a14 = engine.makeVariable();
        a15 = engine.makeVariable();
        a16 = engine.makeVariable();
        a17 = engine.makeVariable();
        a20 = new ListTerm(a10, s6);
        a19 = new ListTerm(a4, a20);
        a18 = new ListTerm(a2, a19);
        p1 = new Predicates.dollar_call_1(a17, cont);
        p2 = new Predicates.eq_stop_stop_2(a17, a18, p1);
        p3 = new Predicates.Mergelist_2(a16, a11, p2);
        p4 = new Predicates.ListpairMap_4(s5, a14, a15, a16, p3);
        p5 = new Predicates.ListpairMap_4(s4, a13, a15, a9, p4);
        p6 = new Predicates.Fitlist_2(a14, a15, p5);
        p7 = new Predicates.ListpairUnzip_3(a12, a13, a14, p6);
        return new Predicates.MapDesignPrime_3(a2, a5, a12, p7);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "design_prime(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}
}

