/*
 * *** Please do not edit ! ***
 * @(#) DoDraw2Map_6.cs
 * @procedure do_draw2_map/6 in mltoprolog.pl
 */

/*
 * @version P# 1.1.3, on Sept 1 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class DoDraw2Map_6 : Predicate {
    static internal readonly Predicate DoDraw2Map_6_1 = new Predicates.DoDraw2Map_6_1();
    static internal readonly Predicate DoDraw2Map_6_2 = new Predicates.DoDraw2Map_6_2();
    static internal readonly Predicate DoDraw2Map_6_sub_1 = new Predicates.DoDraw2Map_6_sub_1();

    public Term arg1, arg2, arg3, arg4, arg5, arg6;

    public DoDraw2Map_6(Term a1, Term a2, Term a3, Term a4, Term a5, Term a6, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        arg6 = a6; 
        this.cont = cont;
    }

    public DoDraw2Map_6(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        arg6 = args[5]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.aregs[6] = arg6;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(DoDraw2Map_6_1, DoDraw2Map_6_sub_1);
    }

    public override int arity() { return 6; }

    public override string ToString() {
        return "do_draw2_map(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ", " + arg6 + ")";
    }
}

sealed class DoDraw2Map_6_sub_1 : DoDraw2Map_6 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(DoDraw2Map_6_2);
    }
}

sealed class DoDraw2Map_6_1 : DoDraw2Map_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.MakeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        a1 = engine.aregs[1].Dereference();
        a2 = engine.aregs[2].Dereference();
        a3 = engine.aregs[3].Dereference();
        a4 = engine.aregs[4].Dereference();
        a5 = engine.aregs[5].Dereference();
        a6 = engine.aregs[6].Dereference();
        Predicate cont = engine.cont;

        if ( !s1.Unify(a4, engine.trail) ) return engine.fail();
        if ( !a5.Unify(a6, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class DoDraw2Map_6_2 : DoDraw2Map_6 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11;
        Predicate p1, p2;
        a1 = engine.aregs[1].Dereference();
        a2 = engine.aregs[2].Dereference();
        a3 = engine.aregs[3].Dereference();
        a4 = engine.aregs[4].Dereference();
        a5 = engine.aregs[5].Dereference();
        a6 = engine.aregs[6].Dereference();
        Predicate cont = engine.cont;

        if ( a4.IsList() ){
            a7 = ((ListTerm)a4).car;
            a8 = ((ListTerm)a4).cdr;
        } else if ( a4.IsVariable() ){
            a7 = engine.makeVariable();
            a8 = engine.makeVariable();
            if ( !a4.Unify(new ListTerm(a7, a8), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a9 = engine.makeVariable();
        a10 = engine.makeVariable();
        a11 = new ListTerm(a9, a6);
        p1 = new Predicates.DoDraw2Map_6(a1, a2, a3, a8, a5, a10, cont);
        p2 = new Predicates.dollar_unify_2(a10, a11, p1);
        return new Predicates.Draw2_5(a1, a2, a3, a7, a9, p2);
    }
}
}

