/*
 * *** Please do not edit ! ***
 * @(#) DrawLabel_4.cs
 * @procedure draw_label/4 in mltoprolog.pl
 */

/*
 * @version P# 1.1.3, on Sept 1 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class DrawLabel_4 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.MakeSymbol("extent", 3);
    static DoubleTerm s2 = new DoubleTerm(-20);
    static DoubleTerm s3 = new DoubleTerm(20);
    static internal readonly IntegerTerm s4 = new IntegerTerm(5);
    static internal readonly Term[] h8 = {s2, s3, s4};
    static internal readonly StructureTerm s5 = new StructureTerm(f1, h8);
    static internal readonly SymbolTerm f6 = SymbolTerm.MakeSymbol("draw_label", 3);

    public Term arg1, arg2, arg3, arg4;

    public DrawLabel_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public DrawLabel_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1;
        a1 = arg1.Dereference();
        a2 = arg2.Dereference();
        a3 = arg3.Dereference();
        a4 = arg4.Dereference();

        if ( !s5.Unify(a4, engine.trail) ) return engine.fail();
        a5 = engine.makeVariable();
        Term[] h7 = {a1, a2, a3};
        a6 = new StructureTerm(f6, h7);
        p1 = new Predicates.dollar_csMethod_3(a5, a6, engine.makeVariable(), cont);
        return new Predicates.Form1_1(a5, p1);
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "draw_label(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}
}

