/*
 * *** Please do not edit ! ***
 * @(#) DrawTree_2.cs
 * @procedure draw_tree/2 in mltoprolog.pl
 */

/*
 * @version P# 1.1.3, on Sept 1 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class DrawTree_2 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.MakeSymbol("extentf");
    static internal readonly SymbolTerm f2 = SymbolTerm.MakeSymbol("pair", 2);
    static internal readonly SymbolTerm f4 = SymbolTerm.MakeSymbol("extent", 3);
    static internal readonly SymbolTerm f6 = SymbolTerm.MakeSymbol("-", 1);
    static internal readonly IntegerTerm s8 = new IntegerTerm(0);

    public Term arg1, arg2;

    public DrawTree_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public DrawTree_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10;
        Predicate p1, p2, p3, p4, p5, p6;
        a1 = arg1.Dereference();
        a2 = arg2.Dereference();

        a3 = engine.makeVariable();
        a5 = engine.makeVariable();
        a6 = engine.makeVariable();
        Term[] h3 = {a5, a6};
        a4 = new StructureTerm(f2, h3);
        a8 = engine.makeVariable();
        Term[] h5 = {a8, engine.makeVariable(), engine.makeVariable()};
        a7 = new StructureTerm(f4, h5);
        a9 = engine.makeVariable();
        Term[] h7 = {a8};
        a10 = new StructureTerm(f6, h7);
        p1 = new Predicates.EndInvokes_0(cont);
        p2 = new Predicates.Draw2_5(a9, s8, a6, a5, engine.makeVariable(), p1);
        p3 = new Predicates.dollar_unify_2(a9, a10, p2);
        p4 = new Predicates.dollar_cut_1(a3, p3);
        p5 = new Predicates.CollapseExtent_2(a6, a7, p4);
        p6 = new Predicates.Design_3(a2, s1, a4, p5);
        return new Predicates.dollar_getLevel_1(a3, p6);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "draw_tree(" + arg1 + ", " + arg2 + ")";
    }
}
}

