/*
 * *** Please do not edit ! ***
 * @(#) Drawlabel_4.cs
 * @procedure drawlabel/4 in mltoprolog.pl
 */

/*
 * @version P# 1.1.3, on Sept 1 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Drawlabel_4 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.MakeSymbol("pair", 2);
    static internal readonly IntegerTerm s2 = new IntegerTerm(10);
    static internal readonly SymbolTerm f3 = SymbolTerm.MakeSymbol("extent", 3);
    static internal readonly IntegerTerm s5 = new IntegerTerm(-1);

    public Term arg1, arg2, arg3, arg4;

    public Drawlabel_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public Drawlabel_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11;
        a1 = arg1.Dereference();
        a2 = arg2.Dereference();
        a3 = arg3.Dereference();
        a4 = arg4.Dereference();

        if ( a4.IsStructure() ){
            if (f1 != ((StructureTerm)a4).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a4).args;
            a5 = args[0];
            a6 = args[1];
        } else if (a4.IsVariable() ){
            a5 = engine.makeVariable();
            a6 = engine.makeVariable();
            Term[] args = {a5, a6};
            if ( !a4.Unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a5.IsStructure() ){
            if (f1 != ((StructureTerm)a5).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a5).args;
            a7 = args[0];
            if ( !a3.Unify(args[1],  engine.trail) )
                return engine.fail();
        } else if (a5.IsVariable() ){
            a7 = engine.makeVariable();
            Term[] args = {a7, a3};
            if ( !a5.Unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a6.IsStructure() ){
            if (f1 != ((StructureTerm)a6).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a6).args;
            a8 = args[0];
            a9 = args[1];
        } else if (a6.IsVariable() ){
            a8 = engine.makeVariable();
            a9 = engine.makeVariable();
            Term[] args = {a8, a9};
            if ( !a6.Unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a10 = engine.makeVariable();
        a11 = engine.makeVariable();
        a12 = engine.makeVariable();
        a14 = engine.makeVariable();
        a15 = engine.makeVariable();
        Term[] h4 = {a14, a15, a9};
        a13 = new StructureTerm(f3, h4);
        a16 = engine.makeVariable();
        a17 = engine.makeVariable();
        a18 = engine.makeVariable();
        a19 = engine.makeVariable();
        p1 = new Predicates.dollar_multi_3(s5, a19, a8, cont);
        p2 = new Predicates.dollar_toInteger_2(a18, a19, p1);
        p3 = new Predicates.dollar_multi_3(s5, a17, a18, p2);
        p4 = new Predicates.dollar_minus_3(a15, a14, a17, p3);
        p5 = new Predicates.dollar_toInteger_2(a16, a7, p4);
        p6 = new Predicates.dollar_plus_3(a2, a14, a16, p5);
        p7 = new Predicates.dollar_unify_2(a12, a13, p6);
        p8 = new Predicates.DrawLabel_4(a1, a10, a11, a12, p7);
        p9 = new Predicates.dollar_toInteger_2(a3, a11, p8);
        p10 = new Predicates.dollar_toInteger_2(a2, a10, p9);
        p11 = new Predicates.dollar_unify_2(engine.makeVariable(), s2, p10);
        return new Predicates.dollar_unify_2(engine.makeVariable(), s2, p11);
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "drawlabel(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}
}

