/*
 * *** Please do not edit ! ***
 * @(#) GenerateFromRoot_4.cs
 * @procedure generate_from_root/4 in mltoprolog.pl
 */

/*
 * @version P# 1.1.3, on Sept 1 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class GenerateFromRoot_4 : Predicate {
    static internal readonly Predicate GenerateFromRoot_4_1 = new Predicates.GenerateFromRoot_4_1();
    static internal readonly Predicate GenerateFromRoot_4_2 = new Predicates.GenerateFromRoot_4_2();
    static internal readonly Predicate GenerateFromRoot_4_sub_1 = new Predicates.GenerateFromRoot_4_sub_1();

    public Term arg1, arg2, arg3, arg4;

    public GenerateFromRoot_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public GenerateFromRoot_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(GenerateFromRoot_4_1, GenerateFromRoot_4_sub_1);
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "generate_from_root(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}

sealed class GenerateFromRoot_4_sub_1 : GenerateFromRoot_4 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(GenerateFromRoot_4_2);
    }
}

sealed class GenerateFromRoot_4_1 : GenerateFromRoot_4 {
    static internal readonly SymbolTerm f1 = SymbolTerm.MakeSymbol("node", 2);
    static internal readonly SymbolTerm s2 = SymbolTerm.MakeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        a1 = engine.aregs[1].Dereference();
        a2 = engine.aregs[2].Dereference();
        a3 = engine.aregs[3].Dereference();
        a4 = engine.aregs[4].Dereference();
        Predicate cont = engine.cont;

        if ( a3.IsStructure() ){
            if (f1 != ((StructureTerm)a3).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a3).args;
            if ( !a1.Unify(args[0],  engine.trail) )
                return engine.fail();
            if ( !s2.Unify(args[1],  engine.trail) )
                return engine.fail();
        } else if (a3.IsVariable() ){
            Term[] args = {a1, s2};
            if ( !a3.Unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( !a2.Unify(a4, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class GenerateFromRoot_4_2 : GenerateFromRoot_4 {
    static internal readonly SymbolTerm f1 = SymbolTerm.MakeSymbol("node", 2);
    static internal readonly IntegerTerm s2 = new IntegerTerm(1);
    static internal readonly SymbolTerm f3 = SymbolTerm.MakeSymbol("generate_from_root_prime", 4);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1;
        a1 = engine.aregs[1].Dereference();
        a2 = engine.aregs[2].Dereference();
        a3 = engine.aregs[3].Dereference();
        a4 = engine.aregs[4].Dereference();
        Predicate cont = engine.cont;

        if ( a3.IsStructure() ){
            if (f1 != ((StructureTerm)a3).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a3).args;
            if ( !a1.Unify(args[0],  engine.trail) )
                return engine.fail();
            a5 = args[1];
        } else if (a3.IsVariable() ){
            a5 = engine.makeVariable();
            Term[] args = {a1, a5};
            if ( !a3.Unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        Term[] h4 = {a1, a2, a7, a6};
        a8 = new StructureTerm(f3, h4);
        p1 = new Predicates.Findall_3(a7, a8, a5, cont);
        return new Predicates.dollar_plus_3(a4, s2, a6, p1);
    }
}
}

