/*
 * *** Please do not edit ! ***
 * @(#) GenerateTree_4.cs
 * @procedure generate_tree/4 in mltoprolog.pl
 */

/*
 * @version P# 1.1.3, on Sept 1 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class GenerateTree_4 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.MakeSymbol("ClassHierarchy_database");
    static internal readonly SymbolTerm f2 = SymbolTerm.MakeSymbol("form1", 1);
    static internal readonly SymbolTerm s4 = SymbolTerm.MakeSymbol("lock");
    static internal readonly IntegerTerm s5 = new IntegerTerm(10);

    public Term arg1, arg2, arg3, arg4;

    public GenerateTree_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public GenerateTree_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8;
        a1 = arg1.Dereference();
        a2 = arg2.Dereference();
        a3 = arg3.Dereference();
        a4 = arg4.Dereference();

        Term[] h3 = {a2};
        a5 = new StructureTerm(f2, h3);
        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        p1 = new Predicates.Unlock_1(s4, cont);
        p2 = new Predicates.DrawTree_2(a1, a9, p1);
        p3 = new Predicates.dollar_unify_2(a9, a6, p2);
        p4 = new Predicates.GenerateFromRoot_3(a1, a8, a7, p3);
        p5 = new Predicates.dollar_unify_2(a8, a3, p4);
        p6 = new Predicates.GetRoot_5(a1, s5, engine.makeVariable(), a6, a7, p5);
        p7 = new Predicates.Lock_1(s4, p6);
        p8 = new Predicates.Assert_1(a5, p7);
        return new Predicates.dollar_loadAssembly_1(s1, p8);
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "generate_tree(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}
}

