/*
 * *** Please do not edit ! ***
 * @(#) MoveextentFn_3.cs
 * @procedure moveextent_fn/3 in mltoprolog.pl
 */

/*
 * @version P# 1.1.3, on Sept 1 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class MoveextentFn_3 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.MakeSymbol("extent", 3);

    public Term arg1, arg2, arg3;

    public MoveextentFn_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public MoveextentFn_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1;
        a1 = arg1.Dereference();
        a2 = arg2.Dereference();
        a3 = arg3.Dereference();

        if ( a1.IsStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a4 = args[0];
            a5 = args[1];
            a6 = args[2];
        } else if (a1.IsVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            a6 = engine.makeVariable();
            Term[] args = {a4, a5, a6};
            if ( !a1.Unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a3.IsStructure() ){
            if (f1 != ((StructureTerm)a3).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a3).args;
            a7 = args[0];
            a8 = args[1];
            if ( !a6.Unify(args[2],  engine.trail) )
                return engine.fail();
        } else if (a3.IsVariable() ){
            a7 = engine.makeVariable();
            a8 = engine.makeVariable();
            Term[] args = {a7, a8, a6};
            if ( !a3.Unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_plus_3(a5, a2, a8, cont);
        return new Predicates.dollar_plus_3(a4, a2, a7, p1);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "moveextent_fn(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}
}

