/*
 * *** Please do not edit ! ***
 * @(#) Movetree_3.cs
 * @procedure movetree/3 in mltoprolog.pl
 */

/*
 * @version P# 1.1.3, on Sept 1 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Movetree_3 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.MakeSymbol("node", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.MakeSymbol("pair", 2);

    public Term arg1, arg2, arg3;

    public Movetree_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public Movetree_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9;
        a1 = arg1.Dereference();
        a2 = arg2.Dereference();
        a3 = arg3.Dereference();

        if ( a1.IsStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a4 = args[0];
            a5 = args[1];
        } else if (a1.IsVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            Term[] args = {a4, a5};
            if ( !a1.Unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a4.IsStructure() ){
            if (f2 != ((StructureTerm)a4).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a4).args;
            a6 = args[0];
            a7 = args[1];
        } else if (a4.IsVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            Term[] args = {a6, a7};
            if ( !a4.Unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a3.IsStructure() ){
            if (f1 != ((StructureTerm)a3).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a3).args;
            a8 = args[0];
            if ( !a5.Unify(args[1],  engine.trail) )
                return engine.fail();
        } else if (a3.IsVariable() ){
            a8 = engine.makeVariable();
            Term[] args = {a8, a5};
            if ( !a3.Unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a8.IsStructure() ){
            if (f2 != ((StructureTerm)a8).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a8).args;
            if ( !a6.Unify(args[0],  engine.trail) )
                return engine.fail();
            a9 = args[1];
        } else if (a8.IsVariable() ){
            a9 = engine.makeVariable();
            Term[] args = {a6, a9};
            if ( !a8.Unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        return new Predicates.dollar_plus_3(a7, a2, a9, cont);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "movetree(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}
}

