/*
 * *** Please do not edit ! ***
 * @(#) Validate_1.cs
 * @procedure validate/1 in mltoprolog.pl
 */

/*
 * @version P# 1.1.3, on Sept 1 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Validate_1 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.MakeSymbol("validate");
    static internal readonly SymbolTerm f2 = SymbolTerm.MakeSymbol("validate", 2);
    static internal readonly IntegerTerm s4 = new IntegerTerm(1);

    public Term arg1;

    public Validate_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public Validate_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4;
        Predicate p1, p2, p3, p4;
        a1 = arg1.Dereference();

        a2 = engine.makeVariable();
        a4 = engine.makeVariable();
        Term[] h3 = {a1, a4};
        a3 = new StructureTerm(f2, h3);
        p1 = new Predicates.dollar_unify_2(a4, s4, cont);
        p2 = new Predicates.colon_2(a2, a3, p1);
        p3 = new Predicates.Form1_1(a2, p2);
        p4 = new Predicates.dollar_nl_0(p3);
        return new Predicates.Write_1(s1, p4);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "validate(" + arg1 + ")";
    }
}
}

